! *******************************************************************
! * In dieser Includedatei sind die Prozeduren zusammengefasst, die *
! * zum Erstellen eines HTTP-Headers gehoren.                       *
! *-----------------------------------------------------------------*
! * Autor :  W. Gerth  April 20, 2000 (Vorlage L. Schreiner)        *
! *******************************************************************
! *LAMO-EXP creates strings for procs LAST_MODIFIED and EXPIRES     *
! *******************************************************************

LAMO_EXP: PROC(DATA CHAR(100),LASTMODDATE CHAR(10),LASTMODTIME CHAR(8))
                   RETURNS(CHAR(100));

    DCL Y                     CHAR(100);    ! internal buffer
    DCL TAG_FIXED15           FIXED(15);
    DCL MONAT_FIXED15         FIXED(15);
    DCL JAHR_FIXED15          FIXED(15);

!   DATA='Last-Modified:'; or DATA='Expires:';  -> see caller

    CONVERT TAG_FIXED15,MONAT_FIXED15,JAHR_FIXED15
             FROM LASTMODDATE BY F(2),X,F(2),X,F(4);

    Y:=TAGNAME(TAG_FIXED15,MONAT_FIXED15,JAHR_FIXED15);
    DATA=KON(DATA,1,LEN(DATA)+1,Y,1,LEN(Y));     ! ..: day
    DATA=KON(DATA,1,LEN(DATA),', ',1,2);         ! ..: day,
    DATA=KON(DATA,1,LEN(DATA)+1,LASTMODDATE,1,2);! ..: day, xx
    DATA.CHAR(LEN(DATA)+1)='-';                  ! ..: day, xx-
    Y:=MONATNAME(MONAT_FIXED15);
    DATA=KON(DATA,1,LEN(DATA),Y,1,LEN(Y));       ! ..: day, xx-month
    DATA=KON(DATA,1,LEN(DATA),'-',1,1);          ! ... day, xx-month-
    DATA=KON(DATA,1,LEN(DATA),LASTMODDATE,7,10); ! ... day, xx-month-year
    DATA:=KON(DATA,1,LEN(DATA)+1,LASTMODTIME,1,8); ! ... year time
    DATA=KON(DATA,1,LEN(DATA)+1,'GMT'\0D0A\'',1,5);! ... year time GMT

     ! VORHER GMT+2. ABER DAMIT LAESST SICH DER VERGLEICH BEI
     ! IF-MODIFIED-SINCE NICHT DURCHFUEHREN,
     ! DA DORT IMMER DIE ZEIT IN GMT ANGEGEBEN WIRD !

    RETURN(DATA);

END; /* LAMO_EXP */

! *******************************************************************
! *    HEADER FGT IN DEN HTTP-KOPF DIE LAENGE DES VOM CLIENT ZU    *
! *  ERWARTENDEN DOKUMENTS EIN UND SENDET DIESEN KOPF ZUM CLIENT !  *
! *                                                                 *
! *                                                                 *
! *-----------------------------------------------------------------*
! * AUTOR : LARS SCHREINER/ all new W. Gerth                        *
! *-----------------------------------------------------------------*
! * ERSTELLT         : 29.04.1998                                   *
! * LETZTE AENDERUNG : 16.02.2005 Header > 255 Zeichen              *
! *******************************************************************

HEADER: PROC( CHILD FIXED,
              LAENGESTR CHAR(12) IDENT,
              CONTENTTYPE CHAR(255),
              AUTHENTICATE CHAR(255),
              METHOD_OR_ERROR FIXED(31) IDENT,
              HTTP_VER FIXED IDENT,
              LASTMODDATE CHAR(10),
              LASTMODTIME CHAR(8),
              stderr DATION OUT ALPHIC IDENT,
              loglink DATION OUT ALPHIC IDENT
            );

 DCL DATA             (10) CHAR(240);
 DCL VOIDPTR               REF STRUCT[];
 DCL C255PTR               REF CHAR(240);
 DCL Y                     CHAR(255);
 DCL NETERROR              FIXED(15)    INIT(0);
 DCL POS                   FIXED(15);
 DCL NETST                 FIXED(15);
 DCL NOT_MODIF             BIT(1);
 DCL AUTH                  BIT(1);
 DCL DateDATE              CHAR(10);
 DCL DateTIME              CHAR(8);
 DCL HeaderLen             FIXED;
 DCL Len                   FIXED;

 NOT_MODIF=FALSE;                           ! Asume 'modified'
 AUTH=FALSE;

 FOR I TO 1 UPB DATA REPEAT
   DATA(I) = ' ' ;
 END;

 C255PTR = DATA(1);
 HeaderLen = 0;

 CASE (HTTP_VER REM 1000)
 ALT(HV_10)
     CONT C255PTR = 'HTTP/1.0 '; Len := 9;
 ALT(HV_11)
     CONT C255PTR = 'HTTP/1.1 '; Len := 9;
 FIN;
 VOIDPTR = C255PTR.CHAR(Len+1);
 C255PTR = VOIDPTR;
 HeaderLen := HeaderLen + Len;

 CASE (METHOD_OR_ERROR REM 1000(31))
   ALT(M_FAIL)
      CASE( METHOD_OR_ERROR // 1000(31))
         ALT (ME_BAD_REQUEST)            CONT C255PTR = '400 Bad Request'\0D0A\''; Len := 17;
         ALT (ME_UNAUTHORIZED)           CONT C255PTR = '401 Unauthorized'\0D0A\''; Len := 18; AUTH = TRUE;
         ALT (ME_FORBIDDEN)              CONT C255PTR = '403 Forbidden'\0D0A\''; Len := 15;
         ALT (ME_FILE_NOT_FOUND)         CONT C255PTR = '404 File not found'\0D0A\''; Len := 20;
         ALT (ME_REQUEST_TIMEOUT)        CONT C255PTR = '408 Request Timeout'\0D0A\''; Len := 21;
         ALT (ME_LENGTH_REQUIRED)        CONT C255PTR = '411 Length Required'\0D0A\''; Len := 21;
         ALT (ME_INTERNAL_ERROR)         CONT C255PTR = '500 Internal Server Error'\0D0A\''; Len := 27;
         ALT (ME_NOT_IMPLEMENTED)        CONT C255PTR = '501 Not Implemented'\0D0A\''; Len := 21;
         ALT (ME_SERVICE_UNAVAILABLE)    CONT C255PTR = '503 Service Unavailable'\0D0A\''; Len := 25;
         ALT (ME_VERSION_NOT_SUPPORTED)  CONT C255PTR = '505 Version not supported'\0D0A\''; Len := 27;
         OUT                             CONT C255PTR = '500 Internal Server Error'\0D0A\''; Len := 27;
      FIN;
   ALT(M_NETERROR)
      CASE( METHOD_OR_ERROR // 1000(31))
         ALT (ME_REQUEST_TIMEOUT)        CONT C255PTR = '408 Request Timeout'\0D0A\''; Len := 21;
         OUT                             CONT C255PTR = '500 Internal Server Error'\0D0A\''; Len := 27;
      FIN;
      HTTP_VER = HV_10_CLOSE;  ! Nach Netzwerkfehler Verbindung schliessen
   ALT(M_GET_FNM)          CONT C255PTR:='304 Not Modified'\0D0A\''; Len := 18;
                           NOT_MODIF=TRUE; LAENGESTR = '0';
   ALT(M_GET_N,M_GET_FMO,M_GET_AP,M_POST_AP)
                           CONT C255PTR:='200 Document follows'\0D0A\''; Len := 22;
   ALT(M_PUT)
                           CONT C255PTR:='204 No Content'\0D0A\''; Len := 16;
                           NOT_MODIF=TRUE; LAENGESTR = '0';
   ALT(M_PUT_CREATED)
                           CONT C255PTR:='201 Created'\0D0A\''; Len := 13;
                           NOT_MODIF=TRUE; LAENGESTR = '0';
 FIN;
 VOIDPTR = C255PTR.CHAR(Len+1);
 C255PTR = VOIDPTR;
 HeaderLen := HeaderLen + Len;

 Y='MIME-Version: 1.0'\0D0A\'';
 Y=KON(Y,1,LEN(Y),ServerName,1,LEN(ServerName));
 Y=KON(Y,1,LEN(Y),''\0D0A\'',1,2);
 Len=LEN(Y);
 CONT C255PTR = Y;
 VOIDPTR = C255PTR.CHAR(Len+1);
 C255PTR = VOIDPTR;
 HeaderLen := HeaderLen + Len;

 CASE (HTTP_VER)
   ALT(HV_11)
     CONT C255PTR = 'Connection: Keep-Alive'\0D0A\''; Len := 24;
   ALT(HV_10_KEEP)
     CONT C255PTR = 'Connection: Keep-Alive'\0D0A\''; Len := 24;
   ALT(HV_10_CLOSE)
     CONT C255PTR = 'Connection: Close'\0D0A\''; Len := 19;
 FIN;
 VOIDPTR = C255PTR.CHAR(Len+1);
 C255PTR = VOIDPTR;
 HeaderLen := HeaderLen + Len;

 IF AUTH THEN
     Y='WWW-Authenticate: Basic realm="';
     Y=KON(Y,1,LEN(Y),AUTHENTICATE,1,LEN(AUTHENTICATE));
     Y=KON(Y,1,LEN(Y),'"'\0D0A\'',1,3);
     Len=LEN(Y);
     CONT C255PTR = Y;
     VOIDPTR = C255PTR.CHAR(Len+1);
     C255PTR = VOIDPTR;
     HeaderLen := HeaderLen + Len;
 FIN;

 IF NOT NOT_MODIF OR ( HTTP_VER == HV_11 ) OR ( HTTP_VER == HV_10_KEEP ) THEN  ! If a modified content_
     Y='Content-Type: ';
     Y=KON(Y,1,LEN(Y),CONTENTTYPE,1,LEN(CONTENTTYPE));
     Y=KON(Y,1,LEN(Y),''\0D0A\'Content-Length: ',1,18);
     Y=KON(Y,1,LEN(Y),LAENGESTR,BEG(LAENGESTR),LEN(LAENGESTR));
     Y=KON(Y,1,LEN(Y),''\0D0A\'',1,2);
     Len=LEN(Y);
     CONT C255PTR = Y;
     VOIDPTR = C255PTR.CHAR(Len+1);
     C255PTR = VOIDPTR;
     HeaderLen := HeaderLen + Len;
 FIN;

 DateDATE:=DATE;
 CONVERT NOW TO DateTIME BY T(8);
 Y:=LAMO_EXP('Date:',DateDATE,DateTIME);
 Len=LEN(Y);
 CONT C255PTR = Y;
 VOIDPTR = C255PTR.CHAR(Len+1);
 C255PTR = VOIDPTR;
 HeaderLen := HeaderLen + Len;

 IF LEN(LASTMODDATE) == 0 AND LEN(LASTMODTIME) == 0 THEN  ! If both not set
    LASTMODDATE:=DATE;
    CONVERT NOW TO LASTMODTIME BY T(8);
    Y:=LAMO_EXP('Last-Modified:',LASTMODDATE,LASTMODTIME);
    Len=LEN(Y);
    CONT C255PTR = Y;
    VOIDPTR = C255PTR.CHAR(Len+1);
    C255PTR = VOIDPTR;
    HeaderLen := HeaderLen + Len;

    Y:=LAMO_EXP('Expires:',LASTMODDATE,LASTMODTIME);
    Len=LEN(Y);
    CONT C255PTR = Y;
    VOIDPTR = C255PTR.CHAR(Len+1);
    C255PTR = VOIDPTR;
    HeaderLen := HeaderLen + Len;
 ELSE
    IF NOT NOT_MODIF AND ( METHOD_OR_ERROR /= M_FAIL ) THEN               ! If not special 3xx xfer
       Y:=LAMO_EXP('Last-Modified:',LASTMODDATE,LASTMODTIME);
       Len=LEN(Y);
       CONT C255PTR = Y;
       VOIDPTR = C255PTR.CHAR(Len+1);
       C255PTR = VOIDPTR;
       HeaderLen := HeaderLen + Len;
    FIN; ! If NOT NOT_MODIF
 FIN; /* IF DATUM EQ '' AND ZEIT EQ '' THEN */

! *******************************************************************
! *  Set a final CR+LF at the end of the file and transmit data     *
! *******************************************************************
 CONT C255PTR = ''\0D0A\''; Len := 2; ! Separator header/body-entity
 VOIDPTR = C255PTR.CHAR(Len+1);
 C255PTR = VOIDPTR;
 HeaderLen := HeaderLen + Len;

 #IF MAXILOG
   PUT 'S: (HEADER) sending ',HeaderLen,' bytes:'
        TO loglink BY A,F(3),A;
   FOR I TO 1 UPB DATA REPEAT
     Len = 0;
     IF ( HeaderLen > Len )
     THEN
       Len = Len + LEN(DATA(I));
       PUT DATA(I) TO loglink BY A(LEN(DATA(I)));
     FIN;
   END;
 #FIN;
 NETST=NETLINK(CHILD,DATA(1).CHAR(1),HeaderLen,SO_WRITE,FLG_PUSH+FLG_WAIT,stderr,loglink);
 NETERROR=NETSTERR(NETST,'1'B,stderr);
 IF NETERROR NE 0 AND NETERROR NE 3 THEN
    #IF SICOLOG;
    #ELSE;
      WRITE 'HTTP-USER: NETERROR in PROC HEADER !'\0D0A\'' TO stderr;
    #FIN;
    #IF MAXILOG+MINILOG
      WRITE 'S: (HEADER): NET-ERROR!' TO loglink;
      NETERROR=NETSTERR(NETST,'1'B,loglink);
    #FIN;

 FIN; /* IF NETERROR NE 0 THEN */

 END; /* HEADER : PROC */



