! *******************************************************************
! * SEND_LISTE sends the list content to the client                 *
! *-----------------------------------------------------------------*
! * AUTOR : W. Gerth 23.04.2000                                     *
! *******************************************************************
SEND_LISTE: PROC( CHILD FIXED,
                  ROOT REF LISTE,
                  stderr DATION OUT ALPHIC IDENT,
                  loglink DATION OUT ALPHIC IDENT
                ) ;

  DCL NETST             FIXED(15) ;
  DCL NETERROR          FIXED(15) ;
  DCL Bytes_to_go       FIXED(31) ;
  DCL Actblock      REF LISTE     ;
  DCL Startadr      REF CHAR(1)   ;

   #IF MAXILOG
    WRITE 'S: SEND_LISTE starting.' TO loglink;
   #FIN;

  Bytes_to_go = ROOT.Indexw;
  Actblock=ROOT;

  /*... Due to a bug in the BSD-socket it is faster to use 512-blocks */
  #DEFINE SENDSIZE = 512 ;

  WHILE Actblock ISNT ROOT.Last REPEAT
    Startadr = Actblock.Array(0);
    TO BLOCKSIZE//SENDSIZE REPEAT
      NETST = NETLINK( CHILD, Startadr, SENDSIZE, SO_WRITE , FLG_PUSH+FLG_WAIT,stderr,loglink ) ;
      NETERROR = NETSTERR( NETST, '1'B, stderr ) ;
      IF NETERROR NE 0 AND NETERROR NE 3 THEN
        /* Wird das Port von der Gegenseite geschlossen (NETERROR=3) so ist das kein Fehler */
        #IF SICOLOG;
        #ELSE;
        WRITE 'HTTP-USER: NETERROR in SENDLISTE WRITE BLOCKSIZE!'\0D0A\'' TO stderr ;
        #FIN;
        #IF MAXILOG+MINILOG
          WRITE 'S: NETERROR in SENDLISTE WRITE BLOCKSIZE!' TO loglink ;
          NETERROR = NETSTERR( NETST, '1'B, loglink ) ;
        #FIN;
      FIN ; /* IF NETERROR NE 0 THEN */
      REFADD( Startadr, SENDSIZE ) ;
    END;

    Bytes_to_go = Bytes_to_go - BLOCKSIZE ;
    Actblock = Actblock.Next ;
  END ;

  /* ... Last we write the incomplete block ............................*/

  NETST = NETLINK( CHILD, Actblock.Array(0), Bytes_to_go FIT 1(15), SO_WRITE, FLG_PUSH+FLG_WAIT,stderr, loglink ) ;

  NETERROR = NETSTERR( NETST, '1'B, stderr ) ;
  IF NETERROR NE 0 AND NETERROR NE 3 THEN
    /* Wird das Port von der Gegenseite geschlossen (NETERROR=3) so ist das kein Fehler */
    #IF SICOLOG
    #ELSE
    WRITE 'HTTP-USER: NETERROR in SENDLISTE WRITE Rest!'\0D0A\'' TO stderr ;
    #FIN;
    #IF MAXILOG+MINILOG
      WRITE 'S: NETERROR in SENDLISTE WRITE Rest!' TO loglink ;
      NETERROR = NETSTERR( NETST, '1'B, loglink ) ;
    #FIN;
  FIN; /* IF NETERROR NE 0 THEN */

  #IF MAXILOG
    PUT 'S: (SENDLIST) ', ROOT.Indexw, ' bytes sent.' TO loglink BY A, F(10), A ;
    WRITE 'S: (SENDLIST) leaving.' TO loglink ;
  #FIN;
END; /* PROC SEND_LISTE */

