/********************************************************************/
/*             H T T P - S E R V E R   (see full header below)      */
/********************************************************************/
#INCLUDE ../EPROM.H

MAXERR=3; MODE=NOLSTOP,DEBUG; /*+T*/ /*+M*/ ! Enable: remove  gap
!MAXERR=3; MODE=NOLSTOP; /* +T*/ /*+M */ ! Enable: remove  gap
#IFDEF P_PPC;      ! Size for PowerPC
   #IF EPROM
     SC=E000,CODE=0,VAR=0;         ! Size depends on selected options, check!
   #ELSE
     #IF MINILOG+MAXILOG
       SC=20000;
     #ELSE
       SC=20800;         ! size depends on selected options, check!
     #FIN;
   #FIN;              ! Take E000 (11000 with +M,+T) for full log
#FIN;
#IFDEF P_68K;      ! Size for 68K
   #IF EPROM
     SC=9B00,CODE=0,VAR=0;         ! Size depends on selected options, check!
   #ELSE
!     SC=D000;         ! Size depends on selected options, check!
     SC=17E00;         ! Size depends on selected options, check!
   #FIN;
#FIN;              ! Take A000 (D000 with +M,+T) for full log
! ********************************************************************

!  Set the following switches according to desired options:
#DEFINE READINI = 1 ;    ! 0=Read Configuration from FRM, 1=Read Configuration from INI
#DEFINE DBG_ME_VERSION = 0 ;

#DEFINE IEP_SOCKET = 1 ; ! 0=IRT/esd-Socket, 1=IEP-Socket
#DEFINE OPEN_MODUS = 0 ; ! 0=Access only to WEBROOT, 1=Access to all
! WARNING: Allowing access to all files is risky: door for intruders!
/*#DEFINE MINILOG    = 0;  ! enable or disable mini-logfile    jetzt EPROM.H */
/*#DEFINE MAXILOG    = 0;  ! enable or disable maxi-logfile    jetzt EPROM.H */
#DEFINE SUPERLOG   = 0;  ! super logging: Show list (root only)

#DEFINE SICOLOG = 0;    ! Logfile for Siempelkamp-System instead Alarm-Dation
#DEFINE SICOPWD = 0;    ! User/Passwords based on PWD_SERV

#DEFINE DEMON_PRIO = 19;

#DEFINE DEMON_PORT = 80;   ! Portnummer

! ********************************************************************
!                                                                    *
!                       H T T P  -  S E R V E R                      *
!                                                                    *
!                       W. GERTH / L. SCHREINER                      *
! ********************************************************************
!                                                                    *
! This program contains the HTTP-demon (Task 'HTTP_Demon'). Beeing   *
! started the demon is always listening at port 80 and will try to   *
! submit any client request to the 'user-workplace', which is unique *
! for the clients IP-Address. If there is no active user-workplace   *
! for the requesting client, the demon will try to install a new     *
! temporary primary shell as user-workplace. The demon will submit   *
! the requesting socket into a cyclic buffer of the workplace and    *
! will force that independent primary shell to call the procedure    *
! 'SERVER' inside this package. This procedure will run directly     *
! under a primary shell named '#HTTPUSRxy). Thus the demon is free   *
! for new requests from other IP-Addresses immediately.              *
!                                                                    *
! 'SERVER' will inspect the request and hand it over to the internal *
! File-Server or to any application program described in the file    *
! named 'HTTPSERV.INI'. A password-protected login mechanism should  *
! be added to block unwanted users.                                   *                                               *
!                                                                    *
! The maximum number of active users at one time is given by the     *
! formula  maxuser = min(MAX_USER,free shell slots inside RTOS)      *
!                                                                    *
! An optional logging system (Switches MAXILOG and MINILOG above) is *
! based on the task named HTTP_Logger. All log entries are written   *
! to that task by message-passing. The task handles I/O via the      *
! 1 KByte sized LOGBUFFER to reduce I/O activity and avoid opened    *
! files during the SERVERs operations. You will find all logs        *
! in the file "HTTPPROT.LOG" in the HTTPDIR.                         *
!                                                                    *
! -------------------------------------------------------------------*
!
!                 P R O G R A M   -   H I S T O R Y
!
!  11/12/1997  0.0 Initial Version by Lars Schreiner                 *
!  24/04/1999  0.1 Extended version by Lars Schreiner                *
!  17/03/2000  1.0 Complete rearrangement by W. Gerth                *
!  05/10/2004  1.1 DirAlias new by J. Bartels/Siempelkamp            *
!  16/02/2005  1.2 HTTP/1.1 new by J. Bartels/Siempelkamp            *
!  16/03/2005  1.3 $HTTPINIDIR new by J. Bartels/Siempelkamp         *
!  18/03/2005  1.4 DEMON_PRIO new by J. Bartels/Siempelkamp          *
!  21/03/2005  1.5 MS-DOS-INI-File by B. Kroll/IEP                   *
!  29/03/2005  1.6 APPLICATION2 new by J. Bartels/Siempelkamp        *
!                  PWD_Serv neu                                      *
!  12/04/2005  1.7 Canonical URL by J.Bartels/Siempelkamp            *
!                  /UPLOAD with filename in URL                      *
!                  HTTP/1.1 corrections after failure                *
!  28/04/2005  1.8 /UPLOAD-failures corr. by J. Bartels/Siempelkamp  *
!                  cleaner design for reading HTTP-header            *
!                  ENV-vars in INI-File                              *
!  03/06/2005  1.9 V1.8 for IRT/esd-sockets by T. Lilge              *
!  14/06/2005  1.10 HTTP/1.0-POST-corrections for IE                 *
!  31/03/2006  1.11 Var pool enlarged by J. Bartels/Siempelkamp      *
!  26/04/2006  1.12 PUT-method implemented by J.Bartels/Siempelkamp  *
!  15/05/2006  1.13 Application3-Pointer by J. Bartels/Siempelkamp   *
!  23/10/2006  1.14 TCP_set_timeout-signature corrected              *
!                   J. Bartels/Siempelkamp                           *
!  08/06/2007  1.15 Applications temporarily disablable              *
!                   J. Bartels/Siempelkamp                           *
!
! ********************************************************************
! * Imported external procs: NETLNK6.AS   for socket I/O             *
! *                          MALLOCS5     for dynamic memory handling*
! *                          RTOUCH       read touch data            *
! *                          RUN_USER     for creation of user-workpl*
! *                          CDL          create dynamic lib-link    *
! *------------------------------------------------------------------*
! * Required initialisation file  HTTPSERV.FRM                       *
! * (must be compiled by special tool from HTTPSERV.INI)             *
! *------------------------------------------------------------------*
! * Source-Includes required:    FILERR.INC                          *
! *                              NETSTERR.INC                        *
! *                              DATUM.INC                           *
! *                              LISTPACK.INC                        *
! *                              DATECOMP.INC                        *
! *                              HEADER.INC                          *
! *                              SENDFILE.INC                        *
! *                              SENDLIST.INC                        *
! *------------------------------------------------------------------*
! * HTML-files required          INDEX.HTM                           *
! *                              HTTP400.HTM                         *
! *                              HTTP404.HTM                         *
! *                              UPLOADOK.HTM                        *
! *                              UPLOADNO.HTM                        *
! *------------------------------------------------------------------*
! * Protocol file generated      HTTPPROT.LOG  (plain ASCII-Text)    *
! *------------------------------------------------------------------*
! ********************************************************************
! * Other Program-Switches (be careful with modifications)           *
! ********************************************************************

   #DEFINE SOCKET_WORKAROUND   = 0;
   ! 1 BEDEUTET DIE SOCKETS WERDEN UEBER EINEN SHELL BEFEHL GESCHLOSSEN !
   ! 0 BEDEUTET DIE SOCKETS WERDEN UEBER EINEN BEFEHL VON NETLINK GESCHLOSSEN !

   #DEFINE MAX_CQ = 1;   !
   ! Gibt die Groesse des Ringbuffers (fuer child-sockets)
   ! vor der ausfuehrenden Shell an

!*********************************************************************
!                   T h e  r e a l   P r o g r a m
!*********************************************************************

SHELLMODULE HTTPD;
 KILL_HTTP:'HTTP_KILL';
 APPL_CLEAN_HTTP: 'HTTP_CLEAN';
 HTTP_DISABLE_MODULE: 'HTTP_DISABLE_MODULE';
 HTTP_ENABLE_MODULE: 'HTTP_ENABLE_MODULE';
 SYSTEM;
! ********************************************************************
! .... Console output is for serious errors only:

   #IF SICOLOG ;
   HTPD_Alarm_out: /VO/LOGFILE ->;
   #ELSE ;
   HTPD_Alarm_out: /TY;
   #FIN ;

! .... If a LOGFILE is required:

   #IF MAXILOG+MINILOG ;
   #FIN ;
    LOGFILE:/A1/xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(TFU=128,NE) ->;
    HTPD_LOGLINK:/A1/xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx(TFU=254,NE) ->;

! ********************************************************************
! * File Definition. Due to multiuser-facility, only masks are used.
! ********************************************************************

   FILEMASK:ED.aaaaaabbbbbbsssssssbbbbaaaAAAAAAAAAaaaaaaaaaaaaaaaDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBaaaa (NE,AI=$0400)<->;
   #IF READINI
   INPFILEMASK:/NIL/ksjkdjskdjksjdksjdksjdksKLSADFIUKLSAFHSAFLDKHSDFLKJASDFLHLKHSF(NE)<->;
   #FIN

 PROBLEM;

   #IF READINI
   SPC INPFILEMASK DATION IN ALPHIC;
   #FIN

! *******************************************************************
! *           Definition of the requested data types
! *******************************************************************

#INCLUDE ../INCLUDE/HTTPALL.INC  SETLINE 9000 ;

#DEFINE MAJORVERSION = 1;
#DEFINE MINORVERSION = 15;
  DCL Version CHAR(20) INIT ( ''\AEB1BF9504C5\'HTTPServ=1.15'\FF\'' );
  DCL ServerName INV CHAR(32) INIT('Server: RTOS-UH-HTTP_Demon/1.15'); ! For self-identification of this server:

  DCL KONFIGURATION_CHANGED BIT(1) INIT('0'B) ;

  TYPE TUSER STRUCT[IPADR FIXED(31),        ! IP-Address of request
                    RMPADR FIXED,           ! Remote port adr
                    OWNIPAD FIXED(31),      ! Own IP-Adress
                    OWNPADR FIXED,          ! Own port adr
                    USERNO FIXED,           ! Internal Shell-number
                    LOGIN  BIT(1),          ! Login-status
                    CHILD  FIXED,           ! The actual child sock
                    CBUF(MAX_CQ) FIXED,     ! Child-sock buffer
                    RI FIXED,               ! Reader-Index
                    WI FIXED,               ! Writer-Index
                    LASTREQ CLOCK           ! Time of last request
                   ];

  TYPE PEARL_CE STRUCT[STATIO FIXED,          ! Statio+LDNIO
                       DRIVE  FIXED,          ! current dfrive
                       MODE   CHAR(2),        ! Mode of operation
                       RECLEN FIXED,          ! Data coming in
                       DATA_ADR REF CHAR(1),  ! Pointer to data start
                       FNAME_ADR REF CHAR(1), ! Pointer to filename
                       USERNO FIXED];         ! User-id of CE

  TYPE FILEPACK STRUCT[Name CHAR(255),        ! Full name of file
             DatPTR REF DATION INOUT ALPHIC,  ! Pointer to Dation
             Status FIXED(15),                ! Status of dation
             Content CHAR(128),               ! Content-type
             Authenticate CHAR(128),          ! Authentication
             Length  FIXED(31),               ! Length of the file
             DateTime CHAR(20)];              ! Data from Touch

! ********************************************************************
!                           Constants
! ********************************************************************

! .....................................................................

! For creation of monthname:

   DCL MONATNAME(1:12) INV CHAR(3)
       INIT('Jan','Feb','Mar','Apr','May','Jun',
            'Jul','Aug','Sep','Oct','Nov','Dec');

! .....................................................................

! For DATE_EQ:

   DCL MSTR1 INV CHAR(36) INIT('JANFEBMARAPRMAYJUNJULAUGSEPOCTNOVDEC');
   DCL MSTR2 INV CHAR(36) INIT('JanFebMarAprMayJunJulAugSepOctNovDec');

! .....................................................................

! For creation of dayname:

   DCL DAYNAME(0:6) INV CHAR(10) INIT('Sunday    ','Monday    ',
                                      'Tuesday   ','Wednesday ',
                         'Thursday  ','Friday    ','Saturday  ');
! .....................................................................

! For conversion to capitals:

   DCL CAPTAB(0:255) CHAR(1);

! .....................................................................

! For identification of the request:
/*
RFC 2068                        HTTP/1.1                    January 1997
   In the interest of robustness, servers SHOULD ignore any empty
   line(s) received where a Request-Line is expected. In other words, if
   the server is reading the protocol stream at the beginning of a
   message and receives a CRLF first, it should ignore the CRLF.

     Note: certain buggy HTTP/1.0 client implementations generate an
     extra CRLF's after a POST request. To restate what is explicitly
     forbidden by the BNF, an HTTP/1.1 client must not preface or follow
     a request with an extra CRLF.

----------
Microsoft Knowledge Base Q823099:

Extra CRLF Character Is Added to a POST Request That Is Sent to an HTTP 1.1 Server

SYMPTOMS
When a POST request is sent to a HTTP 1.1 server, Internet Explorer may append an
extra carriage return and line feed character (CRLF) to the end of the post. This
may cause problems with the server. The network may stop responding (hang) or you
may receive a "Page Not Found" error message, depending on how the server or the
Web application is configured.

CAUSE
This problem occurs because Internet Explorer may incorrectly store gzip compressed
pages with the HTTP 1.0 header. If that page is later requested by Internet Explorer,
it will read the 1.0 header and it will think that it should send an extra CRLF (in
a subsequent POST request). Internet Explorer typically sends an extra CRLF in a POST
request when it thinks that it is communicating with an HTTP 1.0-based server.

*/

   DCL RQTAB(0:3) INV CHAR(4) INIT('GET ','POST','PUT ');
   DCL (GET_IDX,POST_IDX,PUT_IDX) INV FIXED INIT(0,1,2);

!......................................................................
!
! For text-output of method or error

   #IF MAXILOG;
     DCL METAB(0:11) INV CHAR(12) INIT('**NONE**','**FAIL**','**NETERROR**',
                                      'GET FILE','GETF-NMO',
                                      'GETF-MOD','GET APPL','POST UPL',
                                      'POST-APP',
                                      'PUT FILE','PUT CREATED',
                                      'BUGGY');

   #FIN;
!......................................................................
!
! For NETLINK :

   DCL (SO_OPEN,SO_RESERVE,SO_CLOSE,SO_BIND)    INV FIXED INIT(0,1,2,3);
   DCL (SO_CONNECT,SO_SHUT,SO_LISTEN,SO_ACCEPT) INV FIXED INIT(4,5,6,7);
   DCL (SO_READFROM,SO_READ,SO_WRITETO)         INV FIXED INIT(8,9,10);
   DCL (SO_WRITE,SO_SETOPT,SO_GETREMADDR)       INV FIXED INIT(11,12,13);

   DCL PF_INET              INV FIXED INIT(2);    ! Protocol family
   DCL AF_INET              INV FIXED INIT(2);
   DCL FLG_ABORT            INV FIXED INIT(1);
   DCL FLG_PUSH             INV FIXED INIT(1);
   DCL FLG_WAIT             INV FIXED INIT(128);
   DCL SOCK_STREAM          INV FIXED INIT(1);
!......................................................................

! For METHOD_OR_ERROR:

   DCL M_NONE               INV FIXED INIT(0);  ! 'None'
   DCL M_FAIL               INV FIXED INIT(1);  ! 'fail'
   DCL M_NETERROR           INV FIXED INIT(2);  ! 'error at network layer'
   DCL M_GET_N              INV FIXED INIT(3);  ! 'get file no specials'
   DCL M_GET_FNM            INV FIXED INIT(4);  ! 'get file not modified'
   DCL M_GET_FMO            INV FIXED INIT(5);  ! 'get file modified'
   DCL M_GET_AP             INV FIXED INIT(6);  ! 'get from application'
   DCL M_POST_UP            INV FIXED INIT(7);  ! 'POST /UPLOAD
   DCL M_POST_AP            INV FIXED INIT(8);  ! 'POST /Appl.
   DCL M_PUT                INV FIXED INIT(9);  ! 'PUT' file
   DCL M_PUT_CREATED        INV FIXED INIT(10); ! 'PUT' file created
   DCL M_BUGGY              INV FIXED INIT(11); ! Buggy empty request (see RFC 2048)

! HTTP-Error Codes for METHOD_OR_ERROR if BAD_REQU
! Add Messages in HEADERS.INC
   DCL ME_BAD_REQUEST       INV FIXED INIT(400);   ! 400 Bad Request
   DCL ME_UNAUTHORIZED      INV FIXED INIT(401);   ! 401 Unauthorized
   DCL ME_FORBIDDEN         INV FIXED INIT(403);   ! 403 Forbidden
   DCL ME_FILE_NOT_FOUND    INV FIXED INIT(404);   ! 404 File not found
   DCL ME_REQUEST_TIMEOUT   INV FIXED INIT(408);   ! 408 Request Timeout
   DCL ME_LENGTH_REQUIRED   INV FIXED INIT(411);   ! 411 Length Required
   DCL ME_INTERNAL_ERROR    INV FIXED INIT(500);   ! 500 Internal Server Error
   DCL ME_NOT_IMPLEMENTED   INV FIXED INIT(501);   ! 501 Not Implemented
   DCL ME_SERVICE_UNAVAILABLE INV FIXED INIT(503); ! 503 Service Unavailable
   DCL ME_VERSION_NOT_SUPPORTED INV FIXED INIT(505); ! 505 Version not supported

! For HTTP_VER:
   DCL HV_09                INV FIXED INIT(   9);  ! HTTP/0.9
   DCL HV_10                INV FIXED INIT(  10); ! HTTP/1.0
   DCL HV_10_CLOSE          INV FIXED INIT(  10); ! HTTP/1.0
   DCL HV_10_KEEP           INV FIXED INIT(1010); ! HTTP/1.0 Connection: Keep-Alive
   DCL HV_11                INV FIXED INIT(  11); ! HTTP/1.1

! For FILEINFO.Status

   DCL F_INVALID            INV FIXED INIT(0);     ! file name is invalid
   DCL F_N_VALID            INV FIXED INIT(1);     ! file name is valid
   DCL F_OPEN               INV FIXED INIT(2);     ! file is opened

!......................................................................

! General purpose constants:

 DCL (CR,LF)               INV CHAR(1)   INIT(''\0D\'',''\0A\'');
 DCL (TRUE,FALSE)          INV BIT(1)    INIT('1'B,'0'B);
 DCL FFORM30(0:30)  FIXED INIT(1,1,1,1,1,1,1,1,1,1,    !  0 ...  9
                               2,2,2,2,2,2,2,2,2,2,    ! 10 ... 19
                               2,2,2,2,2,2,2,2,2,2,2); ! 20 ... 30

#IF READINI
  #DEFINE INIT_TEMPLATES = 1;
#ELSE
  #DEFINE INIT_TEMPLATES = 0;
#FIN
#INCLUDE ../INCLUDE/INIVAR.INC

TYPE APPLICATIONFUNC REF PROC(REF LISTE,REF LISTE IDENT,REF DATION OUT ALPHIC,FIXED(31));
TYPE APPLICATION2FUNC REF PROC(REF LISTE,REF LISTE IDENT,REF DATION OUT ALPHIC,FIXED(31),FIXED(15),FIXED(31),FIXED(15));
TYPE APPLICATION3FUNC REF PROC(REF LISTE,REF LISTE IDENT,REF DATION OUT ALPHIC,FIXED(31),FIXED(15),FIXED(31),FIXED(15),CHAR(255) IDENT, FIXED IDENT);

TYPE THTTPConfig STRUCT [
   VARTAB(VARTABLEN) VARENTRY,
   TxtPool(TXTPOOLLEN) CHAR(10),
   APPLICATIONPTR(VARTABLEN) REF STRUCT[],
   APPENABLED(VARTABLEN) BIT,
   LOCPATH CHAR(128),    ! Path where to get local docs
   LOCPATH_Len  FIXED   ! Length of local path
];

DCL AktConfig FIXED INIT(0);
DCL HTTPConfig (2) THTTPConfig;
DCL ConfigSema BOLT;

! ********************************************************************
! * Specify importes subroutines                                     *
! ********************************************************************

! ... Memory allocation .............................................

    SPC MALLOC   PROC(FIXED(31),FIXED)  RETURNS(REF STRUCT[]) GLOBAL;
    SPC FREE     PROC(REF STRUCT[] IDENT)     GLOBAL;

! ... Shell execution ...............................................

    SPC EXEC    ENTRY ( CHAR(255)) RETURNS(BIT(1)) GLOBAL;

! ... Date ..........................................................

    SPC DATE     ENTRY RETURNS(CHAR(10)) GLOBAL;

! ... Touch-data ...................................................

    SPC RTOUCH PROC(DATION ALPHIC IDENT) RETURNS(CHAR(20)) GLOBAL;

! ... Environment fetch ............................................

    SPC ENVGET PROC(CHAR(255)) RETURNS(CHAR(255)) GLOBAL;

!--------------------------------------------------------------------
! .... Procs for the handling of workplaces .......................

    SPC RUN_USER PROC(FIXED,                  ! Requested Shell-no.
                      CHAR(8),                ! Name of the shell
                      REF PROC(REF STRUCT[]), ! Proc to call
                      REF STRUCT[],           ! Parameter to xfer
                      FIXED(31))              ! Extra WSP for Task
                      RETURNS(FIXED) GLOBAL;
    SPC GET_USER PROC RETURNS(FIXED) GLOBAL ;
!-------------------------------------------------------------------
! .... Procs for the dynamic linking to the outside applications

    SPC CDL PROC(CHAR(1) IDENT, REF STRUCT[] IDENT) GLOBAL;
!--------------------------------------------------------------------
! .... Procs for the direct handling of communication elements
#IF MAXILOG+MINILOG ;
    SPC TOQ_CE PROC RETURNS(REF STRUCT[]) GLOBAL;
    SPC GET_CE_DATA PROC(REF STRUCT[],PEARL_CE IDENT) GLOBAL;
    SPC RELEASE_CE PROC(REF STRUCT[]) GLOBAL;
#FIN
!--------------------------------------------------------------------
! ....   Spezifications for the network-procs
#IF IEP_SOCKET > 0 ;

 SPC NETLNK ENTRY(FIXED,         ! port number
                  CHAR(1) IDENT, ! Start adr of data
                  FIXED,         ! Len of data
                  FIXED,         ! Network command
                  FIXED,         ! Flags wait=128
                  DATION OUT ALPHIC IDENT,
                  DATION OUT ALPHIC IDENT
                 )
     RETURNS(FIXED) GLOBAL;      ! Completion state

 SPC NET_OPEN ENTRY ( FIXED           ,  ! local Port HTTP !
                      FIXED     IDENT ,  ! ptr on Socketstruct
                      FIXED(31) IDENT ,  ! rem IP-Adresse on connection
                      FIXED     IDENT ,  ! rem Port on connection
                      FIXED(31)  IDENT ,  ! own IP-Adresse on connection
                      FIXED      IDENT ,  ! own Port on connection
                      DATION OUT ALPHIC IDENT,
                      DATION OUT ALPHIC IDENT
                    ) RETURNS( FIXED) GLOBAL ;


#ELSE

 SPC NETLNK ENTRY(FIXED,         ! port number
                  CHAR(1) IDENT, ! Start adr of data
                  FIXED,         ! Len of data
                  FIXED,         ! Network command
                  FIXED          ! Flags wait=128
                 )
     RETURNS(FIXED) GLOBAL;      ! Completion state


#FIN

! ******************************************************************
! ... Specify dations (due to multiuser-facility, most are masks) ...

    SPC HTPD_Alarm_out   DATION OUT ALPHIC;   ! Only for serious errors
    SPC FILEMASK    DATION INOUT ALPHIC; ! Not really used, only mask!

! ... The logging file (if needed!) ................................

    #IF MAXILOG+MINILOG;
    #FIN;
      SPC LOGFILE   DATION OUT ALPHIC;
      SPC HTPD_LOGLINK   DATION OUT ALPHIC;
! *******************************************************************
! *               Variablen, statisch alloziert                     *
! *******************************************************************
!
! Fuer die Nutzerverwaltung:

  DCL USERTAB(MAX_USER) TUSER;
!...................................................................
! Fuer die Kommunikation:

  DCL SOCKET FIXED ;               ! Port 80, wo der Daemon lauscht
!...................................................................
! Fuer das Einloggen:

  DCL DFLOG BIT(1) INIT('1'B);    ! Evtl. durch INI-File uebersteuert

!...................................................................
! For the logfile (if necessary):

  #IF MAXILOG+MINILOG ;
     DCL LOGBUFFER(10)CHAR(100);  ! For buffering of the log output
     DCL LOGBUFCNT FIXED INIT(0); ! The fillstate of the buffer
     DCL LASTLOGDATE CHAR(10);    ! Day of last logging operation
     DCL LASTLOGCLK CLOCK;        ! Time of last logging operation
  #FIN

!...................................................................
! Dateizugriff koordinieren
DCL GLB_FILE_NAMES( MAX_USER ) STRUCT [ t CHAR(128) , cnt FIXED(15) ] ;
DCL GLB_FILE_WAIT( MAX_USER ) SEMA;
DCL GLB_FILE_SEMA             SEMA;
DCL GLB_FILE_FREE             SEMA;


! *******************************************************************
! *         BENOETIGTE INCLUDE-FILES (REIHENFOLGE WICHTIG!)         *
! *******************************************************************

#IF SICOPWD
  SPC ChkUserRight PROC( user CHAR IDENT, pwd CHAR IDENT, right CHAR IDENT ) RETURNS(FIXED) GLOBAL;
  #DEFINE errOk = 0
#FIN

#IF IEP_SOCKET > 0 ;
   #INCLUDE ../INCLUDE/TCP_SOCK.INC SETLINE=3001;
#FIN


#IF SICOLOG ;
! *******************************************************************
! *         Logfilekonstanten fuer Siempelkamp                      *
! *******************************************************************
#DEFINE LC_PROG           = 37;       ! Programmnummer
#DEFINE LC_VOID           =  0;       ! Ohne Worte...
#DEFINE LC_START          =  1;       ! Startmeldung
#DEFINE LC_ENDE           =  2;       ! Endemeldung
#DEFINE LC_RECONFIGSTART  =  3;       ! Rekonfiguration gestartet
#DEFINE LC_RECONFIGOK     =  4;       ! Rekonfiguration ok
#DEFINE LC_RECONFIGERR    =  5;       ! Rekonfiguration ok
#DEFINE LC_ALLOCERROR     = 16;       ! Root-Allocation-Error
#DEFINE LC_APPLNOTFOUND   = 17;       ! Application not found
#DEFINE LC_FILENOTFOUND   = 18;       ! File not found
#DEFINE LC_ENVVAR         = 19;       ! Environment-Variable not found
#DEFINE LC_PATHTOOLONG    = 20;       ! HTTP-Pfad zu lang
#DEFINE LC_FRMNOTOPEN     = 21;       ! FRM kann nicht geoeffnet werden
#DEFINE LC_FRMVERSION     = 22;       ! Falsche Version vom FRM
#DEFINE LC_FRMREADERR     = 23;       ! Lesefehler bei FRM
#DEFINE LC_LOGERROR       = 24;       ! Logfile-Fehler
#DEFINE LC_ACCEPTERR      = 25;       ! Accept-Error
#DEFINE LC_ACCEPTERR4     = 26;       ! vierfacher Accept-Error
#DEFINE LC_TOOMANYUSERS   = 27;       ! Zu viele User
#DEFINE LC_SOCKOVERFLOW   = 28;       ! Socket-Overflow
#DEFINE LC_CLOSEERR       = 29;       ! Fehler bei Close
#DEFINE LC_INIERROR       = 100;      ! Fehler in INI-Datei

GetLogfileCode: PROC( Msg FIXED ) RETURNS(CHAR(17));

DCL Ret CHAR(17);

  CONVERT TOBIT( LC_PROG FIT 0(31) ), ':', TOBIT( Msg FIT 0(31) ) TO Ret BY LIST,A,LIST;

  RETURN( Ret );
END;

#FIN;

!...................................................................
! NETLINK Prozedur mit Verzweiung auf esd/irt- und iep-NETLNK
NETLINK: PROC( PORT FIXED,         ! port number
               DATA CHAR(1) IDENT, ! Start adr of data
               DLEN FIXED,         ! Len of data
               NETC FIXED,         ! Network command
               FLAG FIXED,         ! Flags wait=128
               DERR DATION OUT ALPHIC IDENT,
               DOUT DATION OUT ALPHIC IDENT
                                              ) RETURNS(FIXED) GLOBAL;
#IF IEP_SOCKET > 0 ;
  RETURN(NETLNK(PORT,DATA,DLEN,NETC,FLAG,DERR,DOUT));
#ELSE
  RETURN(NETLNK(PORT,DATA,DLEN,NETC,FLAG));
#FIN

END;

! *******************************************************************
! *         BENOETIGTE INCLUDE-FILES (REIHENFOLGE WICHTIG!)         *
! *******************************************************************

#INCLUDE ../INCLUDE/FILEERR.INC  SETLINE=3201;
#INCLUDE ../INCLUDE/NETSTERR.INC SETLINE=3301;
#INCLUDE ../INCLUDE/LISTPACK.INC SETLINE=3501;
#INCLUDE ../INCLUDE/DATUM.INC    SETLINE=3801;
#INCLUDE ../INCLUDE/DATECOMP.INC SETLINE=4001;
#INCLUDE ../INCLUDE/HEADER.INC   SETLINE=4201;
#INCLUDE ../INCLUDE/SENDFILE.INC SETLINE=4401;
#INCLUDE ../INCLUDE/SENDLIST.INC SETLINE=4601;
#IF READINI
  #INCLUDE ../INCLUDE/INIPROC.INC  SETLINE=5001;
#FIN

! *******************************************************************
!   DECODEBASE64 converts from Base64-encoding                      *
! *******************************************************************
DECODEBASE64: PROC( SRC CHAR(1) IDENT, Len FIXED, DEST CHAR(1) IDENT, MaxNewLen FIXED ) RETURNS( FIXED );

DCL B24 BIT(32);
DCL PB24 REF CHAR(3);  ! points to B24
DCL PEnc REF CHAR;
DCL PDst REF CHAR(3);
DCL VoidPtr REF STRUCT[];
DCL Shift FIXED;
DCL DstLen FIXED;

   ! PEnc to start of encrypted string
   PEnc = SRC;

   ! PDst to start of plain string
   VoidPtr = DEST;
   PDst = VoidPtr;

   ! PB24 to B24
   VoidPtr = B24;
   PB24 = VoidPtr;
   B24 = '00000000'B4;

   Shift = 26;
   DstLen = 0;

   ! loop over encrypted string
   TO Len REPEAT
     CASE PEnc
     ALT('A':'Z')
       B24 = B24 OR ( TOBIT( (TOFIXED(PEnc) - TOFIXED('A') FIT 0(31) +  0(31) ) ) SHIFT Shift );
       Shift = Shift - 6;
     ALT('a':'z')
       B24 = B24 OR ( TOBIT( (TOFIXED(PEnc) - TOFIXED('a') FIT 0(31) + 26(31) ) ) SHIFT Shift );
       Shift = Shift - 6;
     ALT('0':'9')
       B24 = B24 OR ( TOBIT( (TOFIXED(PEnc) - TOFIXED('0') FIT 0(31) + 52(31) ) ) SHIFT Shift );
       Shift = Shift - 6;
     ALT('+')
       B24 = B24 OR ( TOBIT( (TOFIXED(PEnc) - TOFIXED('+') FIT 0(31) + 62(31) ) ) SHIFT Shift );
       Shift = Shift - 6;
     ALT('/')
       B24 = B24 OR ( TOBIT( (TOFIXED(PEnc) - TOFIXED('/') FIT 0(31) + 63(31) ) ) SHIFT Shift );
       Shift = Shift - 6;
     ALT('=')
       Shift = Shift - 6;
     OUT
       ! ignorieren
     FIN;

     IF ( Shift == 2 )
     THEN
       IF DstLen + 3 > MaxNewLen
       THEN
         RETURN( -1 );  ! insuff. space
       FIN;
       PDst.CHAR(1) = TOCHAR( TOFIXED( B24 SHIFT (-24) ) );
       PDst.CHAR(2) = TOCHAR( TOFIXED( B24 SHIFT (-16) ) );
       PDst.CHAR(3) = TOCHAR( TOFIXED( B24 SHIFT (- 8) ) );
       CALL REFADD( PDst, 1 );
       DstLen = DstLen + 3;
       Shift = 26;
       B24 = B24 SHIFT 24;
     FIN;

     CALL REFADD( PEnc, 1 );
   END;

   ! Endeerkennung/Laenge korrigieren
   IF DstLen > 0
   THEN
     CALL REFADD( PDst, (-1) );
     IF PDst.CHAR(2) == TOCHAR( 0 )
     THEN
       DstLen = DstLen - 2;
     ELSE
       IF PDst.CHAR(3) == TOCHAR( 0 )
       THEN
         DstLen = DstLen - 1;
       FIN;
     FIN;
   FIN;

   PEnc = DEST;
   CALL REFADD( PEnc, DstLen );
   FROM DstLen TO MaxNewLen REPEAT
     CONT PEnc = ' ';
     CALL REFADD( PEnc, 1 );
   END;

   RETURN( DstLen );
END;

HTTP_SEARCH_ALIAS: PROC /*+G*/ ( Fname REF CHAR(255) , C255PTR REF CHAR(255) , ENDPOS FIXED(15), VARTAB() VARENTRY IDENT, TxtPool () CHAR(10) IDENT ) RETURNS(BIT(1)) GLOBAL ;
 DCL VOIDPTR REF    STRUCT[];     ! For by type operations
 DCL AliasPtr       REF CHAR(255);

  ! Search for DirAlias
  ! Access is allowed for DirAlias and sub-directories!
  FOR I TO 1 UPB VARTAB WHILE VARTAB(I).Name.CHAR(1) NE '*' REPEAT
    IF VARTAB(I).Descr == vtDirAlias THEN                ! Only if directory alias
      IF INSTR(C255PTR,1,ENDPOS,VARTAB(I).Name,1,LEN(VARTAB(I).Name)) EQ 1 THEN

        VOIDPTR = TxtPool(VARTAB(I).IValue);
        AliasPtr = VOIDPTR;
        CONT Fname = KON(AliasPtr,1,VARTAB(I).Len,
                         C255PTR,LEN(VARTAB(I).Name)+1,255);
        RETURN('1'B) ;
      FIN;
    FIN;
  END;
  RETURN('0'B) ;
END ;

! *********************************************************************
!      This procedure searches a string inside the root-block.
!      The parameter STRING is compared with the capitalized
!      content of the list. The parameter POS serves as a start
!      point and is returned as the position behind the found text.
!      You will not succeed using lower case letters in STRING!
!
!      The static table named CAPTAB(0:255) is required for the compare
! *********************************************************************

SER_LIST_ROOT: PROC(ROOT REF LISTE IDENT,POS FIXED(31) IDENT,
                    STRING CHAR(255), LEN FIXED(31))
                    RETURNS(BIT(1));

 DCL (LASTCOMP,FIRSTCOMP) FIXED(31);
 DCL FIRSTCHAR CHAR(1);                ! For fast scanning
 DCL (TSTPTR,Cx,Cy) REF CHAR(1);
 DCL Result BIT(1);

 IF ROOT.Indexw LT BLOCKSIZE THEN
   LASTCOMP = ROOT.Indexw - LEN;       ! Last character to be tested as 1st
 ELSE
   LASTCOMP = BLOCKSIZE - LEN - 1(31); ! Delimit this to the root
 FIN;

 FIRSTCOMP = POS-1(31); IF POS < 1(31) THEN FIRSTCOMP=0(31); FIN;
 FIRSTCHAR = STRING.CHAR(1);

 TSTPTR=ROOT.Array(FIRSTCOMP);
 FOR I FROM FIRSTCOMP TO LASTCOMP REPEAT
   IF CAPTAB(TOFIXED(TSTPTR)) == FIRSTCHAR THEN  ! Look for a start point
     Cx=TSTPTR; Cy=STRING.CHAR(1);
     Result='1'B;
     FOR J FROM 2 TO LEN FIT 1(15) REPEAT;
       REFADD(Cx,1); REFADD(Cy,1);
       IF CAPTAB(TOFIXED(Cx)) NE Cy THEN Result='0'B; EXIT; FIN;
     END;
     IF Result THEN
       POS=I+LEN+1(31);
       RETURN(Result);
     FIN;
   FIN; ! Testpoint found
   REFADD(TSTPTR,1);
 END;

! ... Here we are if the search failed ...................................

 #IF MINILOG+MAXILOG;
   IF ROOT.Next ISNT NIL THEN
     WRITE 'S or Ax: *** WARNING: SER_LIST_ROOT used but more than 1 block.'
           TO HTPD_LOGLINK;
   FIN;
 #FIN;
 RETURN('0'B);  ! Exit not found

END;  ! SER_LIST_ROOT

SER_LIST_Root: PROC(ROOT REF LISTE IDENT,POS FIXED(31) IDENT,
                    STRING CHAR(255), LEN FIXED(31))
                    RETURNS(BIT(1));

 DCL (LASTCOMP,FIRSTCOMP) FIXED(31);
 DCL FIRSTCHAR CHAR(1);                ! For fast scanning
 DCL (TSTPTR,Cx,Cy) REF CHAR(1);
 DCL Result BIT(1);

 IF ROOT.Indexw LT BLOCKSIZE THEN
   LASTCOMP = ROOT.Indexw - LEN;       ! Last character to be tested as 1st
 ELSE
   LASTCOMP = BLOCKSIZE - LEN - 1(31); ! Delimit this to the root
 FIN;

 FIRSTCOMP = POS-1(31); IF POS < 1(31) THEN FIRSTCOMP=0(31); FIN;
 FIRSTCHAR = STRING.CHAR(1);

 TSTPTR=ROOT.Array(FIRSTCOMP);
 FOR I FROM FIRSTCOMP TO LASTCOMP REPEAT
   IF TSTPTR == FIRSTCHAR THEN  ! Look for a start point
     Cx=TSTPTR; Cy=STRING.CHAR(1);
     Result='1'B;
     FOR J FROM 2 TO LEN FIT 1(15) REPEAT;
       REFADD(Cx,1); REFADD(Cy,1);
       IF Cx NE Cy THEN Result='0'B; EXIT; FIN;
     END;
     IF Result THEN
       POS=I+LEN+1(31);
       RETURN(Result);
     FIN;
   FIN; ! Testpoint found
   REFADD(TSTPTR,1);
 END;

! ... Here we are if the search failed ...................................

 #IF MINILOG+MAXILOG;
   IF ROOT.Next ISNT NIL THEN
     WRITE 'S or Ax: *** WARNING: SER_LIST_Root used but more than 1 block.'
           TO HTPD_LOGLINK;
   FIN;
 #FIN;
 RETURN('0'B);  ! Exit not found

END;  ! SER_LIST_ROOT

! *********************************************************************
!      This procedure searches a boundary-string inside the root-block.
! *********************************************************************

SER_BOUNDARY: PROC(ROOT REF LISTE IDENT,POS FIXED(31) IDENT,
                   BOUNDARY CHAR(255), LEN FIXED(31),
                   NAME CHAR(255) IDENT, DATAPOS FIXED(31) IDENT)
                   RETURNS(BIT(1));

DCL NAMEPOS FIXED(31);
DCL CRLFPOS FIXED(31);
DCL SPOS FIXED(31);
DCL VOIDPTR REF STRUCT[];
DCL C255PTR REF CHAR(255);

  IF NOT SER_LIST_Root(ROOT,POS,BOUNDARY,LEN)   ! Search case sensitive
  THEN
    RETURN('0'B);
  FIN;

  NAMEPOS = POS;
  IF NOT SER_LIST_ROOT(ROOT,NAMEPOS,'NAME=',5)
  THEN
    RETURN('0'B);
  FIN;

  CRLFPOS = NAMEPOS;
  IF NOT SER_LIST_ROOT(ROOT,CRLFPOS,''\0D0A\'',2)
  THEN
    RETURN('0'B);
  FIN;

  SPOS = NAMEPOS;
  IF NOT SER_LIST_ROOT(ROOT,SPOS,';',1)
  THEN
    SPOS = CRLFPOS;
  ELSE
    IF SPOS > CRLFPOS
    THEN
      SPOS = CRLFPOS;
    FIN;
  FIN;

  NAME = ' ';
  VOIDPTR = ROOT.Array( NAMEPOS-1 );
  C255PTR = VOIDPTR;
  NAME = MID( C255PTR, 1, SPOS-NAMEPOS-1 );

  DATAPOS = CRLFPOS-2;
  IF NOT SER_LIST_ROOT(ROOT,DATAPOS,''\0D0A0D0A\'',4)
  THEN
    RETURN('0'B);
  FIN;

  RETURN('1'B);
END;  ! SER_BOUNDARY

SER_BOUNDARY_NAME: PROC(ROOT REF LISTE IDENT,POS FIXED(31) IDENT,
                        BOUNDARY CHAR(255), LEN FIXED(31),
                        NAME CHAR(255) IDENT, DATAPOS FIXED(31) IDENT)
                        RETURNS(BIT(1));

DCL FOUNDNAME CHAR(255);

  IF NOT SER_BOUNDARY(ROOT,POS,BOUNDARY,LEN,FOUNDNAME,DATAPOS)   ! Search case sensitive
  THEN
    RETURN('0'B);
  FIN;

  RETURN( FOUNDNAME == NAME );
END;  ! SER_BOUNDARY_NAME

! *******************************************************************
! * READING_DATA_FROM_CLIENT (RDFC) reads the request from client   *
! *******************************************************************

READING_DATA_FROM_CLIENT : PROC(CHILD FIXED,ROOT REF LISTE IDENT,
                                FILEINFO FILEPACK IDENT,
                                METHOD_OR_ERROR FIXED(31) IDENT,
                                HTTP_VER FIXED IDENT,
                                Cfg THTTPConfig IDENT );

 DCL BUF50   CHAR(50);
 DCL C255PTR REF    CHAR(255);    ! To access chars in root-block
 DCL C255PTR2 REF   CHAR(255);    ! To access chars in root-block
 DCL Content REF    CHAR(128);    ! For fast access to FILEINFO.Content
 DCL Authenticate REF CHAR(128);! For fast access to FILEINFO.Authenticate
 DCL AuthStr        CHAR(255);
 #IF SICOPWD
 DCL Right          CHAR(100);
 DCL UserEndPos     FIXED(15);
 #FIN
 DCL DatPTR  REF DATION INOUT ALPHIC;  ! For fast access to FILEINFO.DatPTR
 DCL ENDPOS         FIXED(15);    ! Where the filename ends
 DCL HTTPPos        FIXED(15);    ! Where the HTTP-Option begins
 DCL Fname   REF    CHAR(255);    ! For fast access to FILEINFO.Name
 DCL Qindexw REF    FIXED(31);    ! Quick access to ROOT.Indexw
 DCL IFMOFLG        BIT(1);       ! IF-MODIF ... found flag
 DCL Namelen        FIXED(15);    ! Length of name
 DCL NETERROR       FIXED(15);
 DCL NETST          FIXED;
 DCL SPOS           FIXED(31);    ! Search position
 DCL SL1POS         FIXED;        ! Pos of 1st slash in filename
 DCL VOIDPTR REF    STRUCT[];     ! For by type operations
 DCL (RQTYP,CMPLEN) FIXED;        ! Request-type, comparelength
 DCL (LPOS1,LPOS2)  FIXED(31);    ! For logging only
 DCL (LPOS3,LPOS4)  FIXED(31);    ! For logging only
 DCL AuthPos        FIXED(31);
 DCL AuthPtr        REF CHAR(255);
 DCL AuthLen        FIXED;
 DCL PwdPtr         REF CHAR(255);
 DCL PwdLen         FIXED;
 DCL AliasPtr       REF CHAR(255);

 DCL LargePTR REF STRUCT[Ar(0:BLOCKSIZE) CHAR(1)];  ! To satisfy WRITE-long
 DCL loc_data     STRUCT[Ar(0:BLOCKSIZE) CHAR(1)];  ! for POST as Buffer
 DCL Contlen_fixed  FIXED(31);    ! Content-length for POST
 DCL BoundaryLen    FIXED(31);    ! Length of boundary in POST
 DCL Dummybit       BIT(1);       ! For SER_LIST_ROOT - call
 DCL PostPath       CHAR(255);    ! Path-list for POST /UPLOAD
 DCL PostPathLen    FIXED;
 DCL Bytes_to_go    FIXED(31);    ! Data-counter in POST
 DCL Itemp          FIXED;        ! Integer-temp
 DCL DirIndex       FIXED;
 DCL UpperDirPos    FIXED;        ! Position of '/../' in URL
 DCL CanonURL       CHAR(255);    ! Canonical URL
 DCL CanonURLPtr    REF CHAR(255);! Pointer to Canonical URL; use instead of C255PTR in URL compares
 DCL CanonEndPos    FIXED;
 DCL ParentDirPos   FIXED;
 DCL UploadResponse CHAR(255);
 DCL UploadResponseLen FIXED(31);
 DCL UploadNo       CHAR(255);
 DCL UploadOk       CHAR(255);
 DCL SearchPath     BIT;
 DCL BoundaryName   CHAR(255);
 DCL Boundary       CHAR(255);
 DCL UploadLen      FIXED(31);

 ! ... Presetting of the fast access REFs ..............................

 Content=FILEINFO.Content;
 Authenticate=FILEINFO.Authenticate;
 Fname  =FILEINFO.Name;
 DatPTR =FILEINFO.DatPTR;

 CONT Fname=' ';
 CONT Authenticate=' ';
 Bytes_to_go = 0;
 Contlen_fixed = 0;

! ... Report reading if requested ............................

 WRITE_TO_LIST(ROOT,SL1POS,1, HTPD_LOGLINK);    ! Dummy write one byte
 IF ROOT IS NIL THEN
    #IF SICOLOG
      PUT GetLogfileCode( LC_ALLOCERROR ) TO HTPD_Alarm_out BY LIST,SKIP;
    #ELSE
      WRITE ''\0D0A\'HTTP_SERVER: Cannot allocate root-block.'\0D0A\''
           TO HTPD_Alarm_out;
    #FIN;
    #IF MAXILOG+MINILOG;
      WRITE 'S: Cannot allocate root-block.' TO HTPD_LOGLINK;
    #FIN;
    METHOD_OR_ERROR=M_FAIL+1000(31)*ME_INTERNAL_ERROR;
    HTTP_VER = HV_10_CLOSE;
    GOTO Handle_File2;
 FIN;

 Qindexw = ROOT.Indexw;           ! For fast access to writer-index
 CONT Qindexw = 0(31) ;
! ... We have a root-block. Now we can read a (first?) block ..........

   LPOS4 = 0(31);     ! Where we start

   /* Suche Ende Request-Line */
   WHILE NOT SER_LIST_ROOT(ROOT,LPOS4,''\0D0A\'',2) REPEAT
       NETST=NETLINK(CHILD,ROOT.Array(Qindexw),
                    BLOCKSIZE-(Qindexw FIT 1(15)),SO_READ,FLG_WAIT,HTPD_Alarm_out, HTPD_LOGLINK);
       IF NETST LT 0 THEN
         #IF MINILOG+MAXILOG;
           WRITE 'S: (RDFC) Net-Error POST 2nd block' TO HTPD_LOGLINK;
           #IF MAXILOG;
             NETERROR=NETSTERR(NETST,'1'B,HTPD_LOGLINK);
           #FIN;
         #FIN;
         RM_LIST(ROOT, HTPD_LOGLINK);
         IF Qindexw == 0
         THEN
           HTTP_VER = HV_10_CLOSE;
           METHOD_OR_ERROR = M_NETERROR;
           RETURN;                ! Continuation makes no sense
         ELSE
           HTTP_VER = HV_10_CLOSE;
           METHOD_OR_ERROR=M_NETERROR+1000(31)*ME_REQUEST_TIMEOUT;
           GOTO Handle_File2;
         FIN;
       FIN;
       CONT Qindexw = Qindexw+NETST;
       IF Qindexw EQ BLOCKSIZE THEN
         /* Block voll und Ende Request-Line nicht gefunden->Notausstieg */
         RM_LIST(ROOT, HTPD_LOGLINK);
         METHOD_OR_ERROR=M_FAIL+1000(31)*ME_BAD_REQUEST;           ! Leads to bad requ.
         HTTP_VER = HV_10_CLOSE;
         GOTO Handle_File2;
       FIN ;
   END;  ! WHILE NOT SER_LIST ...

 IF ( LPOS4 == 3 )   ! Buggy-Request (only CRLF)
 THEN
   METHOD_OR_ERROR = M_BUGGY;
   RETURN;
 FIN;

 #IF SUPERLOG
    WRITE 'S: (RDFC) Request-data : ' TO HTPD_LOGLINK;
    LPOS1=Qindexw;
    LPOS1 = 1(31); LPOS2=LPOS1;
    WHILE SER_LIST_ROOT(ROOT,LPOS2,''\0D0A\'',2) REPEAT
     VOIDPTR=ROOT.Array(LPOS1-1(31));
     C255PTR=VOIDPTR;
     PUT C255PTR TO HTPD_LOGLINK BY A((LPOS2-LPOS1-2(31)) FIT 1(15));
     LPOS1=LPOS2;
    END;
    WRITE 'S: (RDFC) <- End of request-data.' TO HTPD_LOGLINK;
 #FIN; ! PREPROZESSOR-BEFEHL !

 FOR I FROM Qindexw TO Qindexw+254 WHILE I < BLOCKSIZE REPEAT
   ROOT.Array(I) = ' '; ! Clear up one 255-char field
 END;

 VOIDPTR = ROOT.Array(0);
 C255PTR = VOIDPTR;     ! For quick inspection

 CONT Fname=' ';        ! We clear that to all blank;

! ... Dispatch by type of request .....................................

 RQTYP = -1;

 FOR I FROM 0 TO 1 UPB RQTAB REPEAT
   CMPLEN = LEN(RQTAB(I));
   IF INSTR(C255PTR,1,CMPLEN,RQTAB(I),1,CMPLEN) > 0 THEN  ! Inspect request
      RQTYP = I; EXIT;
   FIN;
 END;

   LPOS4 = 4(31);     ! Where we start

   /* Suche Ende Header */
   WHILE NOT SER_LIST_ROOT(ROOT,LPOS4,''\0D0A0D0A\'',4) REPEAT
       NETST=NETLINK(CHILD,ROOT.Array(Qindexw),
                    BLOCKSIZE-(Qindexw FIT 1(15)),SO_READ,FLG_WAIT,HTPD_Alarm_out, HTPD_LOGLINK);
       IF NETST LT 0 THEN
         #IF MINILOG+MAXILOG;
           WRITE 'S: (RDFC) Net-Error POST 2nd block' TO HTPD_LOGLINK;
           #IF MAXILOG;
             NETERROR=NETSTERR(NETST,'1'B,HTPD_LOGLINK);
           #FIN;
         #FIN;
         RM_LIST(ROOT, HTPD_LOGLINK);
         IF Qindexw == 0
         THEN
           HTTP_VER = HV_10_CLOSE;
           METHOD_OR_ERROR = M_NETERROR;
           RETURN;                ! Continuation makes no sense
         ELSE
           HTTP_VER = HV_10_CLOSE;
           METHOD_OR_ERROR=M_NETERROR+1000(31)*ME_REQUEST_TIMEOUT;
           GOTO Handle_File2;
         FIN;
       FIN;
       CONT Qindexw = Qindexw+NETST;
       IF Qindexw EQ BLOCKSIZE THEN
         /* Block voll und Ende Header nicht gefunden->Notausstieg */
         RM_LIST(ROOT, HTPD_LOGLINK);
         METHOD_OR_ERROR=M_FAIL+1000(31)*ME_BAD_REQUEST;           ! Leads to bad requ.
         HTTP_VER = HV_10_CLOSE;
         GOTO Handle_File2;
       FIN ;
   END;  ! WHILE NOT SER_LIST ...

   ROOT.headlen = LPOS4-1 ;
 #IF SUPERLOG
    WRITE 'S: (RDFC) Root-data : ' TO HTPD_LOGLINK;
    LPOS1=Qindexw;
    LPOS1 = 1(31); LPOS2=LPOS1;
    WHILE SER_LIST_ROOT(ROOT,LPOS2,''\0D0A\'',2) REPEAT
     VOIDPTR=ROOT.Array(LPOS1-1(31));
     C255PTR=VOIDPTR;
     PUT C255PTR TO HTPD_LOGLINK BY A((LPOS2-LPOS1-2(31)) FIT 1(15));
     LPOS1=LPOS2;
    END;
    WRITE 'S: (RDFC) <- End of root-data.' TO HTPD_LOGLINK;
 #FIN; ! PREPROZESSOR-BEFEHL !

! ... now we look for the first slash and the end of the req string

 SL1POS = INSTR(C255PTR,4,255,' /',1,2);   ! Start of file name
 IF SL1POS LE 0 THEN
    METHOD_OR_ERROR = M_FAIL+1000(31)*ME_BAD_REQUEST;               ! No slash: cannot decode
    GOTO Handle_File;
 FIN;
 VOIDPTR = ROOT.Array(SL1POS);             ! Array starts at 0
 C255PTR = VOIDPTR;
 SL1POS=SL1POS+1;
 ENDPOS=INSTR(C255PTR,2,255,' HTTP/',1,6);
 IF ENDPOS LE 0 THEN
   METHOD_OR_ERROR = M_FAIL+1000(31)*ME_VERSION_NOT_SUPPORTED;                ! No HTTP/-string: bad rq
   GOTO Handle_File;
 FIN;

 !... search for HTTP-Version
 HTTP_VER= HV_10_CLOSE;
 HTTPPos=INSTR(C255PTR,ENDPOS,255,' HTTP/1.1',1,9);
 IF HTTPPos == ENDPOS
 THEN
   HTTP_VER=HV_11;
 FIN;

  #IF MAXILOG
    PUT 'S: (RDFC) HTTP-Ver: ',HTTP_VER TO
         HTPD_LOGLINK  BY A,F(2);
  #FIN;

 WHILE C255PTR.CHAR(ENDPOS) == ' ' REPEAT  ! should point to last
   ENDPOS=ENDPOS-1;
 END;

! ... extract Content-Length ...............
  IF ( RQTYP == POST_IDX ) OR ( RQTYP == PUT_IDX ) THEN
        ! ... We have the 1st part. Start search for content-length ...........

      LPOS1 = 5(31);

      IF NOT SER_LIST_ROOT(ROOT,LPOS1,'CONTENT-LENGTH:',15) THEN
         METHOD_OR_ERROR = M_FAIL+1000(31)*ME_LENGTH_REQUIRED;
         HTTP_VER = HV_10_CLOSE;
         #IF MAXILOG;
           WRITE 'S: (RDFC) Cannot find content-length in POST /UPLOAD'
                  TO HTPD_LOGLINK;
         #FIN;
         Contlen_fixed = 0;
         GOTO Handle_File;
      FIN;
      VOIDPTR = ROOT.Array(LPOS1-1(31));
      C255PTR2 = VOIDPTR;
      CONVERT Contlen_fixed FROM C255PTR2 BY F(10);
      #IF MAXILOG;
        PUT 'S: (RDFC) POST-Contlen: ',Contlen_fixed TO HTPD_LOGLINK BY A,F(10);
      #FIN;
  ELSE
    Contlen_fixed = 0;
  FIN;

! ... check Connection type ...............
! case 1: HTTP/1.0 and no "Connection: Keep-Alive": HV_10_CLOSE -> Close connection after request
! case 2: HTTP/1.0 and "Connection: Keep-Alive": HV_10_KEEP -> keep connection after request
! case 3: HTTP/1.1: HV_10 -> Close connection after request
  IF ( HTTP_VER == HV_10_CLOSE ) THEN
    LPOS1 = 5(31);

    IF SER_LIST_ROOT(ROOT,LPOS1,'CONNECTION:',11) THEN
      LPOS2 = LPOS1;
      IF SER_LIST_ROOT(ROOT,LPOS2,''\0D0A\'',2) THEN
        FROM LPOS1 TO LPOS2 WHILE ROOT.Array(LPOS1) == ' ' REPEAT
          LPOS1 = LPOS1 + 1;
        END;
        VOIDPTR = ROOT.Array(LPOS1);
        C255PTR2 = VOIDPTR;
        IF INSTR(C255PTR2,1,LPOS2-LPOS1,'Keep-Alive', 1, 10 ) == 1
        THEN
          HTTP_VER = HV_10_KEEP;
        FIN;
      FIN;
    FIN;
 FIN;

 ! ... search for '/../' in URL and build canonical URL
Get_Post_Response:
 UpperDirPos = INSTR( C255PTR, 1, ENDPOS, '/../', 1, 4 );
 IF ( UpperDirPos == 0 )
 THEN
   CanonURLPtr = C255PTR;
   CanonEndPos = ENDPOS;
 ELSE
   CanonURLPtr = CanonURL;
   CanonEndPos = ENDPOS;
   CanonURL = C255PTR;

   WHILE UpperDirPos > 0 REPEAT
     ParentDirPos = UpperDirPos;
     WHILE ParentDirPos > 1 AND CanonURL.CHAR( ParentDirPos - 1 ) /= '/' REPEAT
       ParentDirPos = ParentDirPos - 1;
     END;
     CanonURL = KON( CanonURL, 1, ParentDirPos - 1, CanonURL, UpperDirPos + 4, CanonEndPos );
     CanonEndPos = CanonEndPos - 4 - ( UpperDirPos - ParentDirPos );

     UpperDirPos = INSTR( CanonURL, 1, CanonEndPos, '/../', 1, 4 );
     IF UpperDirPos ==1
     THEN
       METHOD_OR_ERROR = M_FAIL+1000(31)*ME_FORBIDDEN;
       GOTO Handle_File;
     FIN;
   END;
 FIN;

! ... Check if authentication is required
 FOR I TO 1 UPB Cfg.VARTAB WHILE Cfg.VARTAB(I).Name.CHAR(1) NE '*' REPEAT
    IF Cfg.VARTAB(I).Descr == vtAuthenticate THEN                ! Only if authenticate
      VOIDPTR = Cfg.TxtPool(Cfg.VARTAB(I).IValue);
      C255PTR2 = VOIDPTR;
      IF INSTR(CanonURLPtr,1,CanonEndPos,C255PTR2,1,Cfg.VARTAB(I).Len) EQ 1 THEN
        CONVERT Itemp FROM Cfg.VARTAB(I).Name;
        #IF MAXILOG
          PUT 'S: (RDFC) Authenticate: ',
               Cfg.VARTAB(Itemp).Name,C255PTR2,I,Itemp TO
               HTPD_LOGLINK  BY A,A(LEN(Cfg.VARTAB(Itemp).Name)),X,A(Cfg.VARTAB(I).Len);
        #FIN;
        VOIDPTR = Cfg.TxtPool(Cfg.VARTAB(Itemp).IValue);
        PwdPtr = VOIDPTR;
        PwdLen = Cfg.VARTAB(Itemp).Len;
        LPOS1 = 5(31);
        IF NOT SER_LIST_ROOT(ROOT,LPOS1,''\0D0A\'',2)
        THEN
           ! Invalid Request-Format
           METHOD_OR_ERROR = M_FAIL+1000(31)*ME_UNAUTHORIZED;
        ELSE
          IF NOT SER_LIST_ROOT(ROOT,LPOS1,'AUTHORIZATION:',14) THEN
            ! no authorization at all from client
            METHOD_OR_ERROR = M_FAIL+1000(31)*ME_UNAUTHORIZED;
          ELSE
            LPOS2 = LPOS1;
            IF LPOS1 > ROOT.headlen OR NOT SER_LIST_ROOT(ROOT,LPOS2,''\0D0A\'',2) THEN
              ! incomplete authorization from client
              METHOD_OR_ERROR = M_FAIL+1000(31)*ME_UNAUTHORIZED;
            ELSE
              LPOS2 = LPOS2 - 2;
              ! RUBBL
              WHILE LPOS1 < LPOS2 AND ROOT.Array(LPOS1-1) == ' ' REPEAT
                LPOS1 = LPOS1 + 1(31);
              END;
              AuthPos = LPOS1;
              IF NOT SER_LIST_ROOT(ROOT,AuthPos,'BASIC ',6) THEN
                ! no basic authorization from client
                METHOD_OR_ERROR = M_FAIL+1000(31)*ME_UNAUTHORIZED;
              ELSE
                IF AuthPos /= LPOS1 + 6
                THEN
                  ! no basic authorization from client
                  METHOD_OR_ERROR = M_FAIL+1000(31)*ME_UNAUTHORIZED;
                ELSE
                  LPOS1 = AuthPos;
                  ! RUBBL
                  WHILE LPOS1 < LPOS2 AND ROOT.Array(LPOS1-1) == ' ' REPEAT
                    LPOS1 = LPOS1 + 1(31);
                  END;
                  VOIDPTR = ROOT.Array(LPOS1-1);
                  AuthPtr = VOIDPTR;

                  AuthLen = DECODEBASE64( ROOT.Array(LPOS1-1), (LPOS2 - LPOS1) FIT 0(15), AuthStr.CHAR(1), SIZEOF( AuthStr ) FIT 0(15) - 1);
                  #IF SICOPWD
                    UserEndPos = INSTR( AuthStr, 1, AuthLen, ':', 1, 1 );
                    IF ( UserEndPos > 0 )
                       AND ( AuthPtr.CHAR((LPOS2 - LPOS1) FIT 0(15) + 1) == ' ' OR AuthPtr.CHAR((LPOS2 - LPOS1) FIT 0(15) + 1) == ''\0D\'')
                    THEN
                      AuthStr.CHAR( UserEndPos ) = ''\00\'';
                      AuthStr.CHAR( AuthLen + 1 ) = ''\00\'';
                      Right = 'http_' >< Cfg.VARTAB(Itemp).Name;
                      Right = KON( Right, 1, LEN( Right ), '_', 1, 1 );
                      Right = KON( Right, 1, LEN( Right ), C255PTR2, 1, Cfg.VARTAB(I).Len );
                      IF LEN( Right ) < SIZEOF( Right )
                      THEN
                        Right.CHAR( LEN( Right ) + 1 ) = ''\00\'';
                      ELSE
                        Right = ''\00\'';
                      FIN;
                      IF ( ChkUserRight( AuthStr.CHAR(1), AuthStr.CHAR( UserEndPos + 1), Right.CHAR(1) ) == errOk )
                      THEN
                        EXIT;
                      ELSE
                        ! wrong user/password
                        METHOD_OR_ERROR = M_FAIL+1000(31)*ME_UNAUTHORIZED;
                      FIN;
                    ELSE
                      ! wrong user/password
                      METHOD_OR_ERROR = M_FAIL+1000(31)*ME_UNAUTHORIZED;
                    FIN;
                  #ELSE
                    IF INSTR( AuthStr, 1, AuthLen, PwdPtr, 1, PwdLen ) == 1
                       AND ( AuthPtr.CHAR((LPOS2 - LPOS1) FIT 0(15) + 1) == ' ' OR AuthPtr.CHAR((LPOS2 - LPOS1) FIT 0(15) + 1) == ''\0D\'')
                    THEN
                      EXIT;
                    ELSE
                      ! wrong user/password
                      METHOD_OR_ERROR = M_FAIL+1000(31)*ME_UNAUTHORIZED;
                    FIN;
                  #FIN
                FIN;
              FIN;
            FIN;
          FIN;
        FIN;
        IF METHOD_OR_ERROR == M_FAIL+1000(31)*ME_UNAUTHORIZED THEN
           ! request authorization from client (http 401 unauthorized)
           CONT Authenticate = Cfg.VARTAB(Itemp).Name;
           GOTO Handle_File;
        FIN;
      FIN;
    FIN;
  END;

! ... We look for any application (instead of a file name) ...........
 VOIDPTR = ROOT.Array(SL1POS-1);             ! Array starts at 0
 C255PTR = VOIDPTR;
 IF CanonURLPtr.CHAR(2) NE ' ' THEN

! ... Here we discover any application-program ...................

    FOR I FROM 1 TO 1 UPB Cfg.VARTAB REPEAT
      IF    Cfg.VARTAB(I).Descr == vtApplication OR Cfg.VARTAB(I).Descr == vtApplication2
         OR Cfg.VARTAB(I).Descr == vtApplication3 THEN
! PUT C255PTR,' search:',I,VARTAB(I).Name TO HTPD_LOGLINK BY A(20),A,F(3),X,A(LEN(VARTAB(I).Name));

        IF INSTR(CanonURLPtr,1,24,Cfg.VARTAB(I).Name,1,LEN(Cfg.VARTAB(I).Name))
           == 1
           AND
           CanonURLPtr.CHAR(LEN(Cfg.VARTAB(I).Name)+1) EQ '/'
        THEN        ! We found an application
! PUT 'Found' TO HTPD_LOGLINK BY A;
          #IF MAXILOG ;
             PUT 'S: (RDFC) Application requested:',
               Cfg.VARTAB(I).Name
               TO HTPD_LOGLINK BY A,A(LEN(Cfg.VARTAB(I).Name));
          #FIN;

          IF Cfg.APPENABLED(I)
          THEN
            VOIDPTR=Cfg.TxtPool(Cfg.VARTAB(I).IValue);
            CDL(VOIDPTR,Cfg.APPLICATIONPTR(I));   ! Create dynamic link
            IF Cfg.APPLICATIONPTR(I) ISNT NIL THEN
              CASE RQTYP
                ALT(GET_IDX)  METHOD_OR_ERROR = M_GET_AP+I*1000(31);
                  #IF MAXILOG;
                    WRITE 'S: (RDFC) Proccessing GET /application' TO HTPD_LOGLINK;
                  #FIN
                   SL1POS = SL1POS + LEN(Cfg.VARTAB(I).Name ) ;
                   ROOT.datptr = ROOT.Array( SL1POS ) ;
                   WHILE SL1POS LT ENDPOS AND ROOT.datptr NE '?' REPEAT ;
                      CALL REFADD( ROOT.datptr , 1 ) ;
                      SL1POS = SL1POS + 1 ;
                   END ;
                   IF ENDPOS EQ SL1POS THEN
                     ROOT.datptr = NIL ;
                     ROOT.datlen = 0(31) ;
                   ELSE
                     CALL REFADD( ROOT.datptr , 1 ) ; /* hinter das '?' */
                     SL1POS = SL1POS + 1 ;
                     ROOT.datlen = ENDPOS - SL1POS + 4 ; /* +4 weil 'GET ' ist schon berlesen */
                   FIN ;

                ALT(POST_IDX) METHOD_OR_ERROR = M_POST_AP+I*1000(31);
                  #IF MAXILOG;
                    WRITE 'S: (RDFC) Proccessing POST /application' TO HTPD_LOGLINK;
                  #FIN

                ! Here we handle the POST to an application
                 ENDPOS = 1;  ! makes this invalid if Handle_File is used later on

  ! ... Did we collect enough data? Must contain 1 double-crlf ...........

                 ROOT.datptr  = ROOT.Array(ROOT.headlen) ;
                 ROOT.datlen  = Contlen_fixed ;

                 Bytes_to_go = Contlen_fixed - ( Qindexw - ROOT.headlen ) ;

  !              und nun die realen Daten fr die Applikation
                 IF Qindexw LE ( ROOT.headlen + ROOT.datlen ) THEN
                    /* Wir muessen Nachschlag holen */
                    WHILE Bytes_to_go > 0 REPEAT
                      IF Bytes_to_go > BLOCKSIZE THEN
                         Itemp = BLOCKSIZE;
                      ELSE
                         Itemp = Bytes_to_go FIT 1(15);
                      FIN;

                      NETST=NETLINK(CHILD,loc_data.Ar(0),Itemp,SO_READ,FLG_WAIT,HTPD_Alarm_out, HTPD_LOGLINK);
                      #IF MAXILOG;
                        PUT 'S: (RDFC) another packet: ',NETST TO HTPD_LOGLINK BY A,F(4);
                      #FIN;
                      IF NETST LT 0 THEN
                        #IF MINILOG+MAXILOG;
                          WRITE 'S: (RDFC) Net-Error POST rest data' TO HTPD_LOGLINK;
                          #IF MAXILOG;
                            NETERROR=NETSTERR(NETST,'1'B,HTPD_LOGLINK);
                          #FIN;
                        #FIN;
                        METHOD_OR_ERROR=M_NETERROR+1000(31)*ME_REQUEST_TIMEOUT;
                        HTTP_VER = HV_10_CLOSE;
                        GOTO Handle_File2;
                      FIN;
                      VOIDPTR=loc_data.Ar(0);
                      /* in der Speicherstruktur verstauen */
                      WRITE_TO_LIST(ROOT,VOIDPTR,NETST, HTPD_LOGLINK);

                      Bytes_to_go = Bytes_to_go - NETST;
                    END;  ! WHILE Bytes_to_go ...
                  FIN ;

                OUT
                  METHOD_OR_ERROR = M_FAIL+1000(31)*ME_BAD_REQUEST;
                  GOTO Handle_File;
              FIN;

              RETURN;   ! That was all, no application treatment below

            FIN;
          FIN;

          ! ... Here we are if the appl.-module was not found .........

          #IF MAXILOG+MINILOG ;
            PUT 'S: Missing/disabled application module ',CanonURLPtr TO HTPD_LOGLINK
                 BY A,A(CanonEndPos);
          #FIN
          C255PTR = VOIDPTR;
          #IF SICOLOG;
            PUT GetLogfileCode( LC_APPLNOTFOUND ),CanonURLPtr
                TO HTPD_Alarm_out BY LIST,X,A(CanonEndPos),SKIP;
          #ELSE ;
            PUT 'HTTP: Application module ',CanonURLPtr,' not found/disabled'
                TO HTPD_Alarm_out BY SKIP,A,A(CanonEndPos),A,SKIP;
          #FIN;
!          RM_LIST(ROOT, HTPD_LOGLINK);
          METHOD_OR_ERROR=M_FAIL+1000(31)*ME_SERVICE_UNAVAILABLE;           ! Leads to bad requ.
          GOTO Handle_File;

        FIN;
      FIN;
      IF Cfg.VARTAB(I).Name.CHAR(1) == '*' THEN EXIT; FIN; ! empty slot
    END;

 FIN;  ! /xyz given

! ... The main dipatcher ..............................................

!  PUT 'S Normal file ?',C255PTR TO HTPD_LOGLINK BY A,A(30) ;

 CASE RQTYP

  ALT(GET_IDX)
      Bytes_to_go = 0;
      IF CanonURLPtr.CHAR(2) == ' ' THEN            ! Start page request?

! ... We handle the get of a start-page ...............................

        CONT Fname=KON(Cfg.LOCPATH,1,Cfg.LOCPATH_Len,'INDEX.HTM',1,9);
        CONT Content = 'text/html';
        #IF MAXILOG ;
          WRITE 'S: (RDFC) found only  "/".' TO HTPD_LOGLINK;
        #FIN;

      ELSE   ! Taken if not the start-page

        #IF OPEN_MODUS
        IF CanonURLPtr.CHAR(2) == '$' AND CanonURLPtr.CHAR(3) == '/' THEN
           ! Local RTOS absolute Path ?
           CONT Fname=MID(CanonURL,3,CanonEndPos);
        ELSE
           ! Local relative Path
           CONT Fname = KON(Cfg.LOCPATH,1,Cfg.LOCPATH_Len,CanonURLPtr,2,CanonEndPos);
        FIN ;
        #ELSE
        ! Only Access from WEBROOT and below

        CONT Fname = KON(Cfg.LOCPATH,1,Cfg.LOCPATH_Len,CanonURLPtr,2,CanonEndPos);

        IF HTTP_SEARCH_ALIAS( Fname , CanonURLPtr , CanonEndPos, Cfg.VARTAB, Cfg.TxtPool ) THEN
          ;
        FIN ;
        #FIN ;
      FIN;

      GOTO Handle_File;


! ... We are here to process 'POST' ....................................

   ALT(POST_IDX) ;    ! ... Must be the /UPLOAD-Case

      #IF MAXILOG ;
         WRITE 'S: (RDFC) Processing POST /UPLOAD' TO HTPD_LOGLINK;
      #FIN;

      ENDPOS = 1;  ! makes this invalid if Handle_File is used later on

! ... Did we collect enough data? Must contain 3 double-crlf ...........

      ROOT.datptr  = ROOT.Array(ROOT.headlen) ;
      ROOT.datlen  = Contlen_fixed ;

      Bytes_to_go = Contlen_fixed - ( Qindexw - ROOT.headlen ) ;

      IF INSTR(CanonURLPtr,1,7,'/UPLOAD',1,7) LE 0 THEN
        METHOD_OR_ERROR = M_FAIL+1000(31)*ME_FORBIDDEN;
        #IF MAXILOG;
          WRITE 'S: (RDFC) Error: /UPLOAD not found.' TO HTPD_LOGLINK;
        #FIN;
        GOTO Handle_File;
      FIN;

! ... We search the boundary and its length ............................

      LPOS2 = 5(31);

      IF NOT SER_LIST_ROOT(ROOT,LPOS2,'BOUNDARY=',9) THEN
         METHOD_OR_ERROR = M_FAIL+1000(31)*ME_BAD_REQUEST;
         #IF MAXILOG;
           WRITE 'S: (RDFC) Cannot find boundary in POST /UPLOAD'
                  TO HTPD_LOGLINK;
         #FIN;
         GOTO Handle_File;
      FIN;

      LPOS3 = LPOS2;

      Dummybit = SER_LIST_ROOT(ROOT,LPOS3,''\0D0A\'',2);
      BoundaryLen = LPOS3 - LPOS2 -2(31);
      VOIDPTR = ROOT.Array(LPOS2-1);
      C255PTR = VOIDPTR;
      Boundary = ' ';
      Boundary = MID( C255PTR, 1, BoundaryLen );
      #IF MAXILOG;
        PUT 'S: (RDFC) Boundarylen: ',BoundaryLen TO HTPD_LOGLINK BY A,F(3);
      #FIN;

      UploadResponse = ' ';
      PostPath = ' ';
      PostPathLen = 0;
      SearchPath = INSTR(CanonURLPtr,1,8,'/UPLOAD/',1,8) LE 0;
      BoundaryName = ' ';

      LPOS2 = LPOS1;
      WHILE BoundaryName /= '"Datei"' REPEAT
        WHILE NOT SER_BOUNDARY(ROOT,LPOS2,Boundary,BoundaryLen,BoundaryName, LPOS4) REPEAT
          NETST=NETLINK(CHILD,ROOT.Array(Qindexw),
                       BLOCKSIZE-(Qindexw FIT 1(15)),SO_READ,FLG_WAIT,HTPD_Alarm_out, HTPD_LOGLINK);
          IF NETST LT 0 THEN
            #IF MINILOG+MAXILOG;
              WRITE 'S: (RDFC) Net-Error POST /UPLOAD 2nd block' TO HTPD_LOGLINK;
              #IF MAXILOG;
                NETERROR=NETSTERR(NETST,'1'B,HTPD_LOGLINK);
              #FIN;
            #FIN;
            METHOD_OR_ERROR=M_NETERROR+1000(31)*ME_REQUEST_TIMEOUT;
            HTTP_VER = HV_10_CLOSE;
            GOTO Handle_File2;
          FIN;
          CONT Qindexw = Qindexw+NETST;
          Bytes_to_go = Bytes_to_go - NETST;
        END;  ! WHILE NOT SER_BOUNDARY_NAME ...
        IF SearchPath AND BoundaryName=='"PATH"'
        THEN
          VOIDPTR = ROOT.Array(LPOS4-1);
          C255PTR = VOIDPTR;
          PostPathLen = INSTR(C255PTR,1,255,''\0D0A\'',1,2)-1;
          PostPath=' ';
          PostPath = MID(C255PTR,1,PostPathLen);
        FIN;
        IF BoundaryName=='"UploadResponse"'
        THEN
          VOIDPTR = ROOT.Array(LPOS4-1);
          C255PTR = VOIDPTR;
          UploadResponseLen = INSTR(C255PTR,1,255,''\0D0A\'',1,2)-1;
          UploadResponse=' ';
          UploadResponse= MID(C255PTR,1,UploadResponseLen);
        FIN;
      END;

      IF NOT SearchPath
      THEN
        ! Get filename from URL
        PostPathLen = CanonEndPos - 7;
        PostPath =' ';
        PostPath = MID( CanonURLPtr, 8, CanonEndPos );
      FIN;

      IF HTTP_SEARCH_ALIAS( Fname , PostPath, PostPathLen, Cfg.VARTAB, Cfg.TxtPool ) THEN
        PostPath = Fname;
        PostPathLen = LEN(Fname);
      FIN ;

      LPOS2 = INSTR(UploadResponse,1,UploadResponseLen,';',1,1);
      IF LPOS2 <= 0
      THEN
        ! ... default values if not set or incorrect
        UploadOk = '/UPLOADOK.HTM';
        UploadNo = '/UPLOADNO.HTM';
      ELSE
        UploadOk = MID( UploadResponse, 1, LPOS2 - 1 );
        UploadNo = MID( UploadResponse, LPOS2 + 1, 255 );
      FIN;

      UploadLen = Contlen_fixed-LPOS4-BoundaryLen-8+ROOT.headlen+1;

      #IF MAXILOG;
        PUT 'S: (RDFC) POST-data netto-length: ',UploadLen TO HTPD_LOGLINK
             BY A,F(10);
      #FIN;

      IF UploadLen == 0
      THEN
        CONT Fname = UploadNo;
        GOTO POST_Exit;
      FIN;
! ... We open the file to write to .....................................

      CALL ins_file( PostPath );
      OPEN DatPTR BY IDF(PostPath),ANY;
      IF ST(DatPTR) NE 0 THEN
        CALL del_file( PostPath );
        CONT Fname = UploadNo;
        GOTO POST_Exit;
      FIN;
      REWIND(DatPTR);

! ... We write any bytes valid in memory to that file ..................

      LPOS1 = Qindexw+1(31)-LPOS4;
      IF LPOS1 > 0(31) THEN
        IF LPOS1 > UploadLen THEN
          LPOS1=UploadLen;
        FIN;
        LPOS2=LPOS1;
        VOIDPTR = ROOT.Array(LPOS4-1(31));
        LargePTR = VOIDPTR;
        WRITE LargePTR TO DatPTR BY S(LPOS2);
        IF ST(DatPTR) NE 0 THEN
          CALL del_file( PostPath );
          CONT Fname = UploadNo;
          CLOSE DatPTR BY CAN;
          GOTO POST_Exit;
        FIN;
        UploadLen = UploadLen - LPOS1;
      FIN;


! ... We use the root-array as a buffer to copy the rest ...............

      WHILE UploadLen > 0 REPEAT
        IF UploadLen > BLOCKSIZE THEN
           Itemp = BLOCKSIZE;
        ELSE
           Itemp = UploadLen FIT 1(15);
        FIN;

        NETST=NETLINK(CHILD,ROOT.Array(0),Itemp,SO_READ,FLG_WAIT,HTPD_Alarm_out, HTPD_LOGLINK);
        #IF MAXILOG;
          PUT 'S: (RDFC) another packet: ',NETST TO HTPD_LOGLINK BY A,F(4);
        #FIN;
        IF NETST LT 0 THEN
          #IF MINILOG+MAXILOG;
            WRITE 'S: (RDFC) Net-Error POST /UPLOAD rest data' TO HTPD_LOGLINK;
            #IF MAXILOG;
              NETERROR=NETSTERR(NETST,'1'B,HTPD_LOGLINK);
            #FIN;
          #FIN;
          CLOSE DatPTR BY CAN;
          CALL del_file( PostPath );
          METHOD_OR_ERROR=M_NETERROR+1000(31)*ME_REQUEST_TIMEOUT;
          HTTP_VER = HV_10_CLOSE;
          GOTO Handle_File2;
        FIN;
        CONT Qindexw = NETST;
        UploadLen = UploadLen - Qindexw;
        Bytes_to_go = Bytes_to_go - Qindexw;
        VOIDPTR = ROOT.Array(0);
        LargePTR = VOIDPTR;
        WRITE LargePTR TO DatPTR BY S(Qindexw);
        IF Qindexw NE NETST THEN
          #IF MINILOG+MAXILOG;
            WRITE 'S: (RDFC) File-Error POST /UPLOAD rest data' TO HTPD_LOGLINK;
            #IF MAXILOG;
              PUT 'S: (RDFC) File-Error = ',ST(DatPTR) TO HTPD_LOGLINK
                   BY A,F(3);
            #FIN;
          #FIN;
          CLOSE DatPTR BY CAN;
          CALL del_file( PostPath );
          CONT Fname = UploadNo;
          GOTO POST_Exit;
        FIN;
      END;  ! WHILE Bytes_to_go ...

      CLOSE DatPTR;
      CALL del_file( PostPath );
      CONT Fname = UploadOk;

      POST_Exit:

      ! Read any form data behind file content
      WHILE Bytes_to_go > 0 REPEAT
        IF Bytes_to_go > BLOCKSIZE THEN
           Itemp = BLOCKSIZE;
        ELSE
           Itemp = Bytes_to_go FIT 1(15);
        FIN;

        NETST=NETLINK(CHILD,loc_data.Ar(0),Itemp,SO_READ,FLG_WAIT,HTPD_Alarm_out, HTPD_LOGLINK);
        #IF MAXILOG;
          PUT 'S: (RDFC) another packet: ',NETST TO HTPD_LOGLINK BY A,F(4);
        #FIN;
        IF NETST LT 0 THEN
          #IF MINILOG+MAXILOG;
            WRITE 'S: (RDFC) Net-Error POST /UPLOAD rest data' TO HTPD_LOGLINK;
            #IF MAXILOG;
              NETERROR=NETSTERR(NETST,'1'B,HTPD_LOGLINK);
            #FIN;
          #FIN;
          METHOD_OR_ERROR=M_NETERROR+1000(31)*ME_REQUEST_TIMEOUT;
          HTTP_VER = HV_10_CLOSE;
          GOTO Handle_File2;
        FIN;
        Bytes_to_go = Bytes_to_go - NETST;
      END;  ! WHILE Bytes_to_go ...

      Contlen_fixed = 0(31);
      Bytes_to_go = 0;
      RQTYP = GET_IDX;
      C255PTR = Fname;
      ENDPOS = LEN( Fname );

      CONT Qindexw = 1(31);
      GOTO Get_Post_Response;


! ... We are here to process 'PUT' ....................................

   ALT(PUT_IDX) ;    ! ... Must be the /UPLOAD-Case

      #IF MAXILOG ;
         WRITE 'S: (RDFC) Processing PUT /UPLOAD' TO HTPD_LOGLINK;
      #FIN;

      ENDPOS = 1;  ! makes this invalid if Handle_File is used later on

! ... Did we collect enough data? Must contain 3 double-crlf ...........

      ROOT.datptr  = ROOT.Array(ROOT.headlen) ;
      ROOT.datlen  = Contlen_fixed ;

      Bytes_to_go = Contlen_fixed - ( Qindexw - ROOT.headlen ) ;

      IF INSTR(CanonURLPtr,1,8,'/UPLOAD/',1,8) LE 0 THEN
        METHOD_OR_ERROR = M_FAIL+1000(31)*ME_FORBIDDEN;
        #IF MAXILOG;
          WRITE 'S: (RDFC) Error: /UPLOAD not found.' TO HTPD_LOGLINK;
        #FIN;
        GOTO Handle_File;
      FIN;

! ... We search the boundary and its length ............................

      LPOS2 = 5(31);
      LPOS3 = LPOS2;

      UploadResponse = ' ';
      ! Get filename from URL
      PostPathLen = CanonEndPos - 7;
      PostPath =' ';
      PostPath = MID( CanonURLPtr, 8, CanonEndPos );

      IF HTTP_SEARCH_ALIAS( Fname , PostPath, PostPathLen, Cfg.VARTAB, Cfg.TxtPool ) THEN
        PostPath = Fname;
        PostPathLen = LEN(Fname);
      FIN ;

      UploadLen = Contlen_fixed;

      #IF MAXILOG;
        PUT 'S: (RDFC) PUT-data netto-length: ',UploadLen TO HTPD_LOGLINK
             BY A,F(10);
      #FIN;

      IF UploadLen == 0
      THEN
        CONT Fname = UploadNo;
        GOTO PUT_Exit;
      FIN;
! ... We open the file to write to .....................................

      METHOD_OR_ERROR = M_PUT;
      CALL ins_file( PostPath );
      OPEN DatPTR BY IDF(PostPath),OLD;
      IF ST(DatPTR) NE 0 THEN
        OPEN DatPTR BY IDF(PostPath),NEW;
        METHOD_OR_ERROR = M_PUT_CREATED;
        IF ST(DatPTR) NE 0 THEN
          CALL del_file( PostPath );
          METHOD_OR_ERROR = ME_FILE_NOT_FOUND;
          GOTO Handle_File;
        FIN;
      FIN;
      REWIND(DatPTR);

! ... We write any bytes valid in memory to that file ..................

      LPOS1 = Qindexw+1(31)-LPOS4;
      IF LPOS1 > 0(31) THEN
        IF LPOS1 > UploadLen THEN
          LPOS1=UploadLen;
        FIN;
        LPOS2=LPOS1;
        VOIDPTR = ROOT.Array(LPOS4-1(31));
        LargePTR = VOIDPTR;
        WRITE LargePTR TO DatPTR BY S(LPOS2);
        IF ST(DatPTR) NE 0 THEN
          CONT Fname = UploadNo;
          CLOSE DatPTR BY CAN;
          CALL del_file( PostPath );
          METHOD_OR_ERROR = M_FAIL+1000(31)*ME_INTERNAL_ERROR;
          GOTO Handle_File;
        FIN;
        UploadLen = UploadLen - LPOS1;
      FIN;


! ... We use the root-array as a buffer to copy the rest ...............

      WHILE UploadLen > 0 REPEAT
        IF UploadLen > BLOCKSIZE THEN
           Itemp = BLOCKSIZE;
        ELSE
           Itemp = UploadLen FIT 1(15);
        FIN;

        NETST=NETLINK(CHILD,ROOT.Array(0),Itemp,SO_READ,FLG_WAIT,HTPD_Alarm_out, HTPD_LOGLINK);
        #IF MAXILOG;
          PUT 'S: (RDFC) another packet: ',NETST TO HTPD_LOGLINK BY A,F(4);
        #FIN;
        IF NETST LT 0 THEN
          #IF MINILOG+MAXILOG;
            WRITE 'S: (RDFC) Net-Error PUT /UPLOAD rest data' TO HTPD_LOGLINK;
            #IF MAXILOG;
              NETERROR=NETSTERR(NETST,'1'B,HTPD_LOGLINK);
            #FIN;
          #FIN;
          CLOSE DatPTR BY CAN;
          CALL del_file( PostPath );
          METHOD_OR_ERROR=M_NETERROR+1000(31)*ME_REQUEST_TIMEOUT;
          HTTP_VER = HV_10_CLOSE;
          GOTO Handle_File2;
        FIN;
        CONT Qindexw = NETST;
        UploadLen = UploadLen - Qindexw;
        Bytes_to_go = Bytes_to_go - Qindexw;
        VOIDPTR = ROOT.Array(0);
        LargePTR = VOIDPTR;
        WRITE LargePTR TO DatPTR BY S(Qindexw);
        IF Qindexw NE NETST THEN
          #IF MINILOG+MAXILOG;
            WRITE 'S: (RDFC) File-Error PUT /UPLOAD rest data' TO HTPD_LOGLINK;
            #IF MAXILOG;
              PUT 'S: (RDFC) File-Error = ',ST(DatPTR) TO HTPD_LOGLINK
                   BY A,F(3);
            #FIN;
          #FIN;
          CLOSE DatPTR BY CAN;
          CALL del_file( PostPath );
          GOTO PUT_Exit;
        FIN;
      END;  ! WHILE Bytes_to_go ...

      CLOSE DatPTR;
      CALL del_file( PostPath );

PUT_Exit:
      CONT Fname = ' ';
      Contlen_fixed = 0(31);
      Bytes_to_go = 0;
      C255PTR = Fname;
      ENDPOS = LEN( Fname );

      CONT Qindexw = 1(31);
      FILEINFO.Status = F_INVALID;
      RETURN;
   OUT;

 FIN;    ! CASE RQTYP


!-----------------------------------------------------------------------
! ... Handle the file (Preparing SENDFILE, may be bad request) .........
!     Whatever the file is, we open it and read those file data

Handle_File:
  ! ... extract Content-Length ...............
  IF ( RQTYP == POST_IDX ) OR ( RQTYP == PUT_IDX ) THEN
        ! ... We have the 1st part. Start search for content-length ...........

      LPOS1 = 5(31);

      IF NOT SER_LIST_ROOT(ROOT,LPOS1,'CONTENT-LENGTH:',15) THEN
         METHOD_OR_ERROR = M_FAIL+1000(31)*ME_LENGTH_REQUIRED;
         HTTP_VER = HV_10_CLOSE;
         #IF MAXILOG;
           WRITE 'S: (RDFC) Cannot find content-length in POST /UPLOAD'
                  TO HTPD_LOGLINK;
         #FIN;
         Contlen_fixed = 0;
         GOTO Handle_File2;
      FIN;
      VOIDPTR = ROOT.Array(LPOS1-1(31));
      C255PTR2 = VOIDPTR;
      CONVERT Contlen_fixed FROM C255PTR2 BY F(10);
      #IF MAXILOG;
        PUT 'S: (RDFC) POST-Contlen: ',Contlen_fixed TO HTPD_LOGLINK BY A,F(10);
      #FIN;
      Bytes_to_go = Contlen_fixed - ( Qindexw - ROOT.headlen ) ;
  ELSE
    Contlen_fixed = 0;
    Bytes_to_go = 0;
  FIN;

  IF ( ( HTTP_VER == HV_11 ) OR ( HTTP_VER == HV_10_KEEP ) ) AND ( Bytes_to_go > 0 )
  THEN
!   und nun die realen Daten fuer die Tonne
     IF Qindexw LE ( ROOT.headlen + ROOT.datlen ) THEN
        /* Wir muessen Nachschlag holen */
        WHILE Bytes_to_go > 0 REPEAT
          IF Bytes_to_go > BLOCKSIZE THEN
             Itemp = BLOCKSIZE;
          ELSE
             Itemp = Bytes_to_go FIT 1(15);
          FIN;

          NETST=NETLINK(CHILD,loc_data.Ar(0),Itemp,SO_READ,FLG_WAIT,HTPD_Alarm_out, HTPD_LOGLINK);
          #IF MAXILOG;
            PUT 'S: (RDFC) another packet: ',NETST TO HTPD_LOGLINK BY A,F(4);
          #FIN;
          IF NETST LT 0 THEN
            #IF MINILOG+MAXILOG;
              WRITE 'S: (RDFC) Net-Error POST rest data' TO HTPD_LOGLINK;
              #IF MAXILOG;
                NETERROR=NETSTERR(NETST,'1'B,HTPD_LOGLINK);
              #FIN;
            #FIN;
            METHOD_OR_ERROR=M_NETERROR+1000(31)*ME_REQUEST_TIMEOUT;
            HTTP_VER = HV_10_CLOSE;
            GOTO Handle_File2;
          FIN;

          Bytes_to_go = Bytes_to_go - NETST;
        END;  ! WHILE Bytes_to_go ...
      FIN ;
  FIN;

Handle_File2:
 IF METHOD_OR_ERROR REM 1000(31)== M_FAIL THEN
   CONT Fname = ' ';
   CONVERT Cfg.LOCPATH, 'HTTP',METHOD_OR_ERROR // 1000(31), '.HTM' TO Fname BY A(Cfg.LOCPATH_Len),A,F(3),A;
   CONT Content='text/html';
 ELSE   ! No bad request

! ... We try to identify the content-type of the file .................

   METHOD_OR_ERROR=M_GET_N;       ! assume get file no options

   CONT Content='application/octet-stream';      ! Fall back type
   Namelen=LEN(Fname);

   FOR I TO 1 UPB Cfg.VARTAB WHILE Cfg.VARTAB(I).Name.CHAR(1) NE '*' REPEAT
     IF Cfg.VARTAB(I).Descr == vtFileType THEN                ! Only if file-type
       IF INSTR(Fname,1,Namelen,
                Cfg.VARTAB(I).Name,1,LEN(Cfg.VARTAB(I).Name)) GT 0 THEN

         VOIDPTR=Cfg.TxtPool(Cfg.VARTAB(I).IValue);
         C255PTR=VOIDPTR;
         CONT Content=' ';
         CONT Content=MID(C255PTR,1,Cfg.VARTAB(I).Len);
         #IF MAXILOG
           PUT 'S: (RDFC) Recognized appendix: ',
                Cfg.VARTAB(I).Name TO
                 HTPD_LOGLINK  BY A,A(LEN(Cfg.VARTAB(I).Name));
         #FIN;
         EXIT;
       FIN;
     FIN;
   END;
 FIN;

 #IF MAXILOG;
   PUT 'S: (RDFC) Filename: ',Fname TO HTPD_LOGLINK BY A,A(LEN(Fname));
   PUT 'S: (RDFC) Content-type: ',Content
        TO HTPD_LOGLINK BY A,A(LEN(Content));
 #FIN;

! ... At this position we have a filename, a content-type .............
!     We try to open that file, otherwise we switch to HTTP-Error 404


 IFMOFLG=FALSE;

 CALL ins_file( Fname );
 FILEINFO.Status = F_INVALID;
 OPEN DatPTR BY IDF(Fname),OLD;
 IF ST(DatPTR) NE 0 THEN          ! Unable to open file?
   CALL del_file( Fname );
   #IF MAXILOG;
     PUT 'S: (RDFC) 404-Error with ',Fname
       TO HTPD_LOGLINK BY A,A(LEN(Fname));
   #FIN;
   IF METHOD_OR_ERROR REM 1000(31) == M_FAIL   ! evtl. Fehlercode nicht ueberdecken
   THEN
     RETURN;
   FIN;

   METHOD_OR_ERROR=M_FAIL+1000(31)*ME_FILE_NOT_FOUND;         ! File not found
   CONT Fname= ' ';
   CONT Fname=KON(Cfg.LOCPATH,1,Cfg.LOCPATH_Len,'HTTP404.HTM',1,11);
   CONT Content='text/html';
   CALL ins_file( Fname );
   OPEN DatPTR BY IDF(Fname),OLD;
   IF ST(DatPTR) NE 0 THEN
     CALL del_file( Fname );
     #IF SICOLOG;
       PUT GetLogfileCode( LC_FILENOTFOUND ),Fname
          TO HTPD_Alarm_out BY LIST,X,A(LEN(Fname)),SKIP;
     #ELSE;
       PUT 'HTTP_SERV: Cannot open file ',Fname
          TO HTPD_Alarm_out BY A,A(LEN(Fname));
     #FIN;
     #IF MAXILOG+MINILOG;
       PUT 'S: (RDFC) Cannot find file ',Fname
        TO HTPD_LOGLINK BY A,A(LEN(Fname));
     #FIN;
     RETURN;
   FIN;

 ELSE   ! This means: addressed file is open

! ... We inspect whether the string "if-modified-since" is found
   IF METHOD_OR_ERROR == M_GET_N THEN
     SPOS = ENDPOS;    ! Start behind filename
     IF SER_LIST_ROOT(ROOT,SPOS,'IF-MODIFIED-SINCE:',18) THEN
        IFMOFLG=TRUE;
        VOIDPTR = ROOT.Array(SPOS-1);  ! Take as char(50);
        C255PTR = VOIDPTR;
        BUF50 = MID(C255PTR,1,50);
     FIN;
   FIN; !
 FIN;  ! IF ST() NE 0

! ... The file is opened now, grab date and length....................

 APPEND(DatPTR);   ! Position at the end
 SAVEP(DatPTR,FILEINFO.Length);
 REWIND(DatPTR);
 FILEINFO.Status = F_OPEN;
 FILEINFO.DateTime =RTOUCH(DatPTR);

! ... If client offers not to send the file, we compare dates .......

 IF IFMOFLG THEN
   IF DATE_EQU(BUF50,FILEINFO.DateTime,HTPD_LOGLINK) THEN
     METHOD_OR_ERROR=M_GET_FNM;         ! File not modified
   ELSE
     METHOD_OR_ERROR=M_GET_FMO;         ! File
   FIN;
 FIN; ! If IFMOFLG

END; ! READING_DATA_FROM_CLIENT !


! *******************************************************************
! * WRITING_DATA_TO_CLIENT SENDET DIE DATEN/FILES AN DEN CLIENT !   *
! *******************************************************************

WRITING_DATA_TO_CLIENT : PROC (CHILD FIXED,ROOT REF LISTE IDENT,
                                  FILEINFO FILEPACK IDENT,
                                  METHOD_OR_ERROR FIXED(31) IDENT,
                                  HTTP_VER FIXED,
                                  Cfg THTTPConfig IDENT,
                                  OWNIPAD FIXED(31),
                                  OWNPADR FIXED,
                                  IPADR FIXED(31),
                                  RMPADR FIXED);

  DCL AP_IDX FIXED;
  DCL CONTENT_TYPE  CHAR(128);
  DCL DATUM CHAR(10);
  DCL LENGTXT CHAR(12);

  DCL APPPTR APPLICATIONFUNC;
  DCL APP2PTR APPLICATION2FUNC;
  DCL APP3PTR APPLICATION3FUNC;

  DCL MIME CHAR(255);
  DCL STATUS FIXED;

  DCL VOIDPTR REF STRUCT[];
  DCL C255PTR REF CHAR(255);
  DCL OUTROOT REF LISTE;          ! resulting root from application

  DCL ZEIT CHAR(8);


  #IF MAXILOG
    WRITE 'S: (WDTC) Writing data to client.' TO HTPD_LOGLINK;
  #FIN;

  CASE (METHOD_OR_ERROR REM 1000(31))

    ALT(M_FAIL,M_GET_N,M_GET_FNM,M_GET_FMO) ! xmit a file

      IF FILEINFO.Status == F_OPEN
      THEN
        CONVERT FILEINFO.Length TO LENGTXT BY F(10),(2)X;
        DATUM = MID(FILEINFO.DateTime,11,20);
        ZEIT  = MID(FILEINFO.DateTime,1,8);
      ELSE
        LENGTXT = '0';
        DATUM = ' ';
        ZEIT = ' ';
      FIN;
      HEADER(CHILD,LENGTXT,FILEINFO.Content,FILEINFO.Authenticate,METHOD_OR_ERROR,HTTP_VER,DATUM,ZEIT,HTPD_Alarm_out, HTPD_LOGLINK );
      IF METHOD_OR_ERROR NE M_GET_FNM THEN
          SENDFILE(CHILD,FILEINFO,HTPD_Alarm_out, HTPD_LOGLINK );       ! No send if not modified
      ELSE
          CLOSE FILEINFO.DatPTR;
          CALL del_file( FILEINFO.Name );
      FIN;

    ALT(M_GET_AP,M_POST_AP)         ! call an application

      IF ROOT ISNT NIL THEN
         MIME = ' ';
         STATUS = 200;
         AP_IDX=( METHOD_OR_ERROR//1000(31) ) FIT AP_IDX; ! calc application number
         CASE (Cfg.VARTAB(AP_IDX).Descr)
          ALT (vtApplication)
             APPPTR = Cfg.APPLICATIONPTR(AP_IDX);
             #IF MAXILOG+MINILOG
              APPPTR(ROOT,OUTROOT,HTPD_LOGLINK,Cfg.VARTAB(OWN_IP_IDX).IValue); ! Execute application subr.
             #ELSE
              APPPTR(ROOT,OUTROOT,NIL,Cfg.VARTAB(OWN_IP_IDX).IValue);     ! Execute application subr.
             #FIN ;
          ALT (vtApplication2)
             APP2PTR = Cfg.APPLICATIONPTR(AP_IDX);
             #IF MAXILOG+MINILOG
              APP2PTR(ROOT,OUTROOT,HTPD_LOGLINK,OWNIPAD, OWNPADR, IPADR, RMPADR); ! Execute application subr.
             #ELSE
              APP2PTR(ROOT,OUTROOT,NIL,OWNIPAD, OWNPADR, IPADR, RMPADR); ! Execute application subr.
             #FIN ;
          ALT (vtApplication3)
             APP3PTR = Cfg.APPLICATIONPTR(AP_IDX);
             #IF MAXILOG+MINILOG
              APP3PTR(ROOT,OUTROOT,HTPD_LOGLINK,OWNIPAD, OWNPADR, IPADR, RMPADR, MIME, STATUS ); ! Execute application subr.
             #ELSE
              APP3PTR(ROOT,OUTROOT,NIL,OWNIPAD, OWNPADR, IPADR, RMPADR, MIME, STATUS); ! Execute application subr.
             #FIN ;
             IF STATUS /= 200
             THEN
               METHOD_OR_ERROR = M_FAIL + STATUS * 1000(31);
             FIN;
          OUT
            ROOT = NIL;
          FIN;
         IF ROOT ISNT NIL
         THEN
           ROOT=OUTROOT;
           CONVERT ROOT.Indexw TO LENGTXT BY F(10),(2)X; ! Length of data
           #IF MAXILOG
             WRITE 'S: (WDTC) Back from application' TO HTPD_LOGLINK;
           #FIN;

           IF LEN( MIME ) == 0
           THEN
             CASE ROOT.Indexr     ! Inspect data-type returned
               ALT (0) HEADER(CHILD,LENGTXT,'text/html','',METHOD_OR_ERROR,HTTP_VER,'','',HTPD_Alarm_out, HTPD_LOGLINK );
               ALT (1) HEADER(CHILD,LENGTXT,'image/png','',METHOD_OR_ERROR,HTTP_VER,'','',HTPD_Alarm_out, HTPD_LOGLINK );
               ALT (2) HEADER(CHILD,LENGTXT,'text/xml','',METHOD_OR_ERROR,HTTP_VER,'','',HTPD_Alarm_out, HTPD_LOGLINK );
             FIN;
           ELSE
              HEADER(CHILD,LENGTXT,MIME,'',METHOD_OR_ERROR,HTTP_VER,'','',HTPD_Alarm_out, HTPD_LOGLINK );
           FIN;
           SEND_LISTE(CHILD,ROOT,HTPD_Alarm_out, HTPD_LOGLINK);
         FIN;
      FIN ;
    ALT(M_POST_UP) ; ! ... POST with /UPLOAD: all was done in RDFC

    ALT(M_PUT,M_PUT_CREATED) ; ! ... PUT with /UPLOAD
      LENGTXT = '0';
      HEADER(CHILD,LENGTXT,' ',' ',METHOD_OR_ERROR,HTTP_VER,' ', ' ',HTPD_Alarm_out, HTPD_LOGLINK );

    ALT(M_BUGGY) ;   ! ... Buggy Empty Request
  FIN;  ! Case-FIN

  RM_LIST(ROOT, HTPD_LOGLINK);

END; ! WRITING_DATA_TO_CLIENT !


! *******************************************************************
! * CLOSESOCKET SCHLIESST DIE IM UEBERGEBENE SOCKET !               *
! *******************************************************************
    CLOSESOCKET : PROC (CHILD FIXED IDENT);


DCL SHELL_STATUS              BIT(1);
DCL SHELL_BEFEHL              CHAR(255)     INIT('');
DCL DUMMY                     CHAR(1);
DCL NETERROR                  FIXED(15)     INIT(0);
DCL NETST                     FIXED INIT(0);

#IF SOCKET_WORKAROUND > 0; ! PREPROZESSOR-BEFEHL !
     DCL STATUS                BIT(1)        INIT('0'B);
     DCL SHELL_BEFEHL_BUFFER   CHAR(255)     INIT('');
     DCL CHILD_KONV            CHAR(2)       INIT('');
#FIN; ! SOCKET_WORKAROUND !  ! PREPROZESSOR-BEFEHL !

    #IF MAXILOG
      PUT 'S: Closing socket: ',CHILD TO HTPD_LOGLINK BY A,F(6);
    #FIN; ! PREPROZESSOR-BEFEHL !

    #IF SOCKET_WORKAROUND > 0; ! PREPROZESSOR-BEFEHL !
        SHELL_BEFEHL:='';
        SHELL_BEFEHL_BUFFER:='';
        SHELL_BEFEHL:=KON(SHELL_BEFEHL,1,LEN(SHELL_BEFEHL)+1,
                          SHELL_BEFEHL_BUFFER,1,LEN(SHELL_BEFEHL_BUFFER)+1);
        CONVERT CHILD TO CHILD_KONV BY F(2),A;
        SHELL_BEFEHL:=KON(SHELL_BEFEHL,1,LEN(SHELL_BEFEHL)+1,CHILD_KONV,1,
                          LEN(CHILD_KONV));
        #IF MAXILOG
           PUT 'S: Closing Socket: SHELL_Instruction:',SHELL_BEFEHL TO
                HTPD_LOGLINK BY A,A(LEN(SHELL_BEFEHL));
        #FIN; ! MAXILOG
        AFTER 1 SEC RESUME;
        STATUS:=EXEC(SHELL_BEFEHL);
        #IF MAXILOG
            IF STATUS NE '0'B THEN
             PUT 'S: Status is ERROR after CLOSING SOCKET. STATUS :',
                  STATUS TO HTPD_LOGLINK BY A,F(3);
            FIN;
        #FIN; ! MAXILOG
    #ELSE ! SOCKET_WORKAROUND ! ! PREPROZESSOR-BEFEHL !
        NETST=NETLINK(CHILD,DUMMY,0,SO_CLOSE,0,HTPD_Alarm_out, HTPD_LOGLINK);
        #IF MAXILOG
        IF NETST LT 0 THEN
            WRITE 'S: NETERROR in CLOSING SOCKET !' TO
                HTPD_LOGLINK;
            NETERROR=NETSTERR(NETST,'1'B,HTPD_LOGLINK);
        FIN ;
        #FIN; ! PREPROZESSOR-BEFEHL !
    #FIN; ! SOCKET_WORKAROUND !  ! PREPROZESSOR-BEFEHL !

    CHILD= -1 ;
END; ! END OF CLOSESOCKET !

#IF IEP_SOCKET > 0 ;
#ELSE

! *******************************************************************
! * STARTSEQUENZ KONFIGURIERT NETLINK MIT IP-PROTOKOLL, IP-ADRESSE, *
! * 15 SOCKETS IN DER QUEUE UND DAS IM LISTEN STATE GEARBEITET WIRD.*
! *******************************************************************
 STARTSEQUENZ: PROC(NETST FIXED IDENT, Cfg THTTPConfig IDENT);
    DCL DUMMY                 CHAR(1);
    DCL Y                     CHAR(255)     INIT('');
    DCL NETERROR              FIXED(15)     INIT(0);
    DCL VOIDPTR REF STRUCT[];
    DCL C1PTR REF CHAR(1);

   ! Open socket and get handle
    NETST=NETLINK(-1,DUMMY,0,SO_OPEN,FLG_WAIT,HTPD_Alarm_out, HTPD_LOGLINK);
    IF NETST GE 0 THEN
       SOCKET=NETST;
    ELSE
      WRITE ''\0D0A\'Init-Error: cannot install socket for port 80!'\0D0A\''
            TO HTPD_Alarm_out;
        #IF MAXILOG+MINILOG
          WRITE 'S: Init-Error: cannot install socket for port 80' TO HTPD_LOGLINK;
          NETERROR=NETSTERR(NETST,'1'B,HTPD_LOGLINK);
       #FIN;
       GOTO InitError2;
    FIN;

  !  Reserve socket and specify protocol
    Y.CHAR(1)=TOCHAR(0);
    Y.CHAR(2)=TOCHAR(SOCK_STREAM);
    Y.CHAR(3)=TOCHAR(0);
    Y.CHAR(4)=TOCHAR(PF_INET);
    Y.CHAR(5)=TOCHAR(0);
    Y.CHAR(6)=TOCHAR(0);
    NETST=NETLINK(SOCKET,Y.CHAR(1),6,SO_RESERVE,0,HTPD_Alarm_out, HTPD_LOGLINK);
    NETERROR=NETSTERR(NETST,'1'B,HTPD_Alarm_out);
    IF NETERROR NE 0 THEN
      #IF MAXILOG+MINILOG
          WRITE 'S: Init-Error: Cannot reserve socket!' TO HTPD_LOGLINK;
          NETERROR=NETSTERR(NETST,'1'B,HTPD_LOGLINK);
      #FIN;! PREPROZESSOR-BEFEHL !
      GOTO InitError;
    FIN; ! IF NETERR NE 0 THEN !

  !  Bind socket to local port
    Y.CHAR(1)=TOCHAR(0);
    Y.CHAR(2)=TOCHAR(AF_INET);
    Y.CHAR(3)=TOCHAR(0);

    Y.CHAR(4)=TOCHAR(DEMON_PORT);  ! HTTP-port

    VOIDPTR = Cfg.VARTAB(OWN_IP_IDX).IValue; C1PTR = VOIDPTR;

    Y.CHAR(5)=C1PTR; REFADD (C1PTR,1);   ! Own internet adr
    Y.CHAR(6)=C1PTR; REFADD (C1PTR,1);   ! Own internet adr
    Y.CHAR(7)=C1PTR; REFADD (C1PTR,1);   ! Own internet adr
    Y.CHAR(8)=C1PTR;                     ! Own internet adr

    NETST=NETLINK(SOCKET,Y.CHAR(1),16,SO_BIND,0,HTPD_Alarm_out, HTPD_LOGLINK);
    NETERROR=NETSTERR(NETST,'1'B,HTPD_Alarm_out);
    IF NETERROR NE 0 THEN
      #IF MAXILOG+MINILOG
         WRITE 'S: Init-Error: Binding of socket failed!' TO HTPD_LOGLINK;
         NETERROR=NETSTERR(NETST,'1'B,HTPD_LOGLINK);
      #FIN;! PREPROZESSOR-BEFEHL !
      GOTO InitError;
    FIN; ! IF NETERR NE 0 THEN !

  !  Open socket to listen state
    Y.CHAR(1)=TOCHAR(0);
    Y.CHAR(2)=TOCHAR(Cfg.VARTAB(Q_LEN_IDX).IValue); ! VORHER QLEN=15
    NETST=NETLINK(SOCKET,Y.CHAR(1),2,SO_LISTEN,FLG_WAIT,HTPD_Alarm_out, HTPD_LOGLINK);
    NETERROR=NETSTERR(NETST,'1'B,HTPD_Alarm_out);
    IF NETERROR NE 0 THEN
       WRITE ' Init_Error: Cannot go to listen-State. Check own IP-Address!'\0A0D\''
             TO HTPD_Alarm_out;
      #IF MAXILOG+MINILOG
          WRITE 'S: Init-Error: Cannot go to listen-state' TO HTPD_LOGLINK;
          NETERROR=NETSTERR(NETST,'1'B,HTPD_LOGLINK);
      #FIN; ! PREPROZESSOR-BEFEHL !
      GOTO InitError;
    FIN; ! IF NETERR NE 0 THEN !
    RETURN;
!
 InitError:
    CLOSESOCKET(SOCKET);
 InitError2:
    #IF MAXILOG+MINILOG
     WRITE ''\04\'' TO HTPD_LOGLINK;
    #FIN
    TERMINATE;
 END; ! STARTSEQUENZ !

#FIN

READ_KONFIGURATION: PROC RETURNS(BIT(1));

 #IF READINI
   DCL FILEX DATION IN ALPHIC CREATED(INPFILEMASK);   ! Internal File
   DCL INIPATH CHAR(255);
   DCL Nxttxt FIXED(31);
   DCL Itemp FIXED(31);
   DCL Itemp2 FIXED(31);
#FIN
 DCL MY_STRING  CHAR(255);
 DCL FRMFILE DATION IN ALPHIC CREATED(FILEMASK);
 DCL Tabversion CHAR(8);
 DCL VARTAB (VARTABLEN) VARENTRY;
 DCL TxtPool (TXTPOOLLEN) CHAR(10);
 DCL NewConfig FIXED;
 DCL Cfg REF THTTPConfig;

! .... Get the actual environment .....................................


 MY_STRING= ENVGET('$HTTPDIR');      ! Temporary misused CHAR(255)
 IF MY_STRING.CHAR(1) == '$' THEN    ! Not resolved?
  #IF SICOLOG ;
    PUT GetLogfileCode( LC_ENVVAR ) TO HTPD_Alarm_out BY LIST,SKIP;
  #ELSE;
    WRITE ''\0D0A\'You must specify the environment var "HTTPDIR" before!'\0D0A\''
      TO HTPD_Alarm_out;
  #FIN;
  RETURN('0'B);
 FIN;

 RESERVE ConfigSema;
 IF AktConfig == 2
 THEN
   NewConfig = 1;
 ELSE
   NewConfig = 2;
 FIN;
 Cfg = HTTPConfig( NewConfig );

! .... Environment given, check length ...............................

 Cfg.LOCPATH_Len = LEN(MY_STRING);
 IF Cfg.LOCPATH_Len > SIZEOF(Cfg.LOCPATH)-1 THEN
  FREE ConfigSema;
  #IF SICOLOG;
    PUT GetLogfileCode( LC_PATHTOOLONG ) TO HTPD_Alarm_out BY LIST,SKIP;
  #ELSE ;
    WRITE ''\0A0D\'HTTP-path too long!'\0D0A\'' TO HTPD_Alarm_out;
  #FIN;
  RETURN('0'B);
 FIN;
 Cfg.LOCPATH=MY_STRING;
 IF Cfg.LOCPATH.CHAR(Cfg.LOCPATH_Len) NE '/' THEN
    Cfg.LOCPATH_Len = Cfg.LOCPATH_Len+1;
    Cfg.LOCPATH.CHAR(Cfg.LOCPATH_Len) = '/';
 FIN;

! .... Reset all dynamic lib links to 'void' ......................

 FOR I TO 1 UPB Cfg.APPLICATIONPTR REPEAT Cfg.APPLICATIONPTR(I)=NIL; END;
 FOR I TO 1 UPB Cfg.APPENABLED REPEAT Cfg.APPENABLED(I)='1'B; END;

 #IF READINI
!------------------------------------------------------------------------------
! .... Read the INI-File ......................................................
 Tabversion = Tabversionreq;
 TableInit( Cfg.VARTAB, Cfg.TxtPool, Nxttxt ) ;

 MY_STRING= ENVGET('$HTTPINIDIR');      ! Temporary misused CHAR(255)
 IF MY_STRING.CHAR(1) == '$' THEN    ! Not resolved?
   INIPATH=KON(Cfg.LOCPATH,1,LEN(Cfg.LOCPATH),'HTTPSERV.INI',1,13);
 ELSE
   IF MY_STRING.CHAR(LEN(MY_STRING)) NE '/' THEN
      MY_STRING.CHAR(LEN(MY_STRING)+1) = '/';
   FIN;
   INIPATH=KON(MY_STRING,1,LEN(MY_STRING),'HTTPSERV.INI',1,13);
 FIN;

 Itemp=INIREAD(FILEX,Cfg.VARTAB,Cfg.TxtPool,INIPATH,Nxttxt);
 Itemp2=Itemp//10000(31);
 IF Itemp2 /= 0
 THEN
   FREE ConfigSema;
   #IF SICOLOG
     IF Itemp2 >=1 AND Itemp2 <=8
     THEN
       PUT GetLogfileCode( LC_INIERROR + Itemp2 FIT 0(15)), Itemp-Itemp2*10000(31), KON( Cfg.LOCPATH, 1, Cfg.LOCPATH_Len, 'HTTPSERV.INI', 1,12 )
         TO HTPD_Alarm_out BY LIST,X,LIST,X,A(Cfg.LOCPATH_Len+12),SKIP;
     ELSE
       PUT GetLogfileCode( LC_INIERROR ), Itemp2, Itemp-Itemp2*10000(31), KON( Cfg.LOCPATH, 1, Cfg.LOCPATH_Len, 'HTTPSERV.INI', 1,12 )
         TO HTPD_Alarm_out BY LIST,X,LIST,X,LIST,X,A(Cfg.LOCPATH_Len+12),SKIP;
     FIN;
   #ELSE;
     WRITE ''\0D0A\'Error in HTTPSERV.INI'\0D0A\''
        TO HTPD_Alarm_out;
   #FIN;
   RETURN('0'B);
 FIN;
 #ELSE
!------------------------------------------------------------------------------
! .... Read the Frame (HTTPSERV.FRM) ..........................................

 OPEN FRMFILE BY IDF(KON(Cfg.LOCPATH,1,Cfg.LOCPATH_Len,'HTTPSERV.FRM',1,12)),
      OLD;
 IF ST(FRMFILE) NE 0 THEN
   FREE ConfigSema;
   #IF SICOLOG
     PUT GetLogfileCode( LC_FRMNOTOPEN ), KON( Cfg.LOCPATH, 1, Cfg.LOCPATH_Len, 'HTTPSER.FRM', 1,12 )
       TO HTPD_Alarm_out BY LIST,X,A(Cfg.LOCPATH_Len+12),SKIP;
   #ELSE;
     WRITE ''\0D0A\'Cannot process frame HTTPSERV.FRM'\0D0A\''
        TO HTPD_Alarm_out;
   #FIN;
   RETURN('0'B);
 FIN;
 READ Tabversion FROM FRMFILE;
 IF Tabversion NE Tabversionreq THEN
   FREE ConfigSema;
   #IF SICOLOG;
      PUT GetLogfileCode( LC_FRMVERSION ), Tabversion, Tabversionreq TO HTPD_Alarm_out BY LIST,X,A,X,A,SKIP;
   #ELSE;
     PUT 'Wrong version of .FRM - file:', Tabversion,' instead of ',
        Tabversionreq TO HTPD_Alarm_out BY SKIP,A,SKIP,(3)A,SKIP;
   #FIN;
   RETURN('0'B);
 FIN;
 READ VARTAB,TxtPool FROM FRMFILE;
 Cfg.VARTAB = VARTAB;
 Cfg.TxtPool = TxtPool;
 IF ST(FRMFILE) NE 0 THEN
   FREE ConfigSema;
   #IF SICOLOG ;
     PUT GetLogfileCode( LC_FRMREADERR ),ST(FRMFILE) TO HTPD_Alarm_out BY LIST,X,LIST,SKIP;
   #ELSE;
     WRITE ''\0D0A\'Read Error with HTTPSERV.FRM!'\0D0A\''
       TO HTPD_Alarm_out;
   #FIN;
   RETURN('0'B) ;
 FIN;
 CLOSE FRMFILE;
 !------------------------------------------------------------------------------
 #FIN

 AktConfig = NewConfig;
 FREE ConfigSema;
 RETURN('1'B) ;
END ;

!*******************************************************************
!    This is what the primary shell will call                      *
!*******************************************************************
SERVER:PROC (From_Demon REF STRUCT[]);

 DCL ACT_USER REF TUSER;

 DCL CHILD_SERV              FIXED;                  ! Port, mit dem der Server arbeitet
 DCL DYN_STATUS              FIXED(15)     INIT(0);
 DCL METHOD_OR_ERROR         FIXED(31);
 DCL HTTP_VER                FIXED;
 DCL ROOT                    REF LISTE;                  ! Das Datenkonstrukt (MALLOC);
 DCL TI                      FIXED;                      ! Temp int
 DCL FILEINFO                FILEPACK;                   ! The dation info
 DCL SERVFILE DATION INOUT ALPHIC CREATED(FILEMASK);     ! for all I/O
 DCL ok BIT(1) ;
 DCL Cfg REF THTTPConfig;

 ACT_USER = From_Demon;                               ! The para pointer
 ACT_USER.USERNO = GET_USER;                          ! If newly installed

 FILEINFO.DatPTR = SERVFILE;                          ! Set the REF

!........ The main Loop processes socket after socket  .................

 HTTP_VER = HV_10_CLOSE;
 CHILD_SERV = -1;
 REPEAT

   IF HTTP_VER == HV_10_CLOSE
   THEN
     IF ( CHILD_SERV >= 0 )
     THEN
       CALL CLOSESOCKET(CHILD_SERV);
     FIN;
     TI = ACT_USER.RI;                                  ! Reader-Index
     IF TI == ACT_USER.WI THEN                          ! Empty?
        ACT_USER.CHILD = -1  ;                            ! No childsock
        ACT_USER.RI = 1;
        ACT_USER.WI = 1;
        RETURN;                                         ! Terminate
     FIN;

     CHILD_SERV = ACT_USER.CBUF(TI);                    ! child in progress
!     TI = TI+1; IF TI > MAX_CQ THEN TI =1; FIN;         ! cycle index
     TI = TI+1;
     ACT_USER.RI = TI;                                  ! Next slot
     ACT_USER.CHILD = CHILD_SERV;                       ! For outside

   FIN;
   ! .... Get Server Configuration.....................................

   ENTER ConfigSema;
   Cfg = HTTPConfig(AktConfig);

   ROOT=NIL;                                 ! Set list to empty state
   FILEINFO.Status =F_INVALID;               ! Is invalid so far
   METHOD_OR_ERROR =M_NONE;                  ! No method so far

   READING_DATA_FROM_CLIENT(CHILD_SERV,ROOT,FILEINFO,METHOD_OR_ERROR,HTTP_VER,Cfg);
   IF ( METHOD_OR_ERROR REM 1000(31)== M_NETERROR AND ( HTTP_VER == HV_11 OR HTTP_VER == HV_10_KEEP ) )
   THEN
      ! Kein neuer Request bei HTTP/1.1 innerhalb der Timeoutzeit -> Ende
      HTTP_VER = HV_10_CLOSE;
   ELSE
     ACT_USER.LASTREQ = NOW ;  ! last access this port ####KROLL####

     #IF MAXILOG;
       PUT 'S: (SRVR) Method_or_error: ',METAB(METHOD_OR_ERROR REM 1000(31))
            TO HTPD_LOGLINK BY A,A;
     #FIN;

      WRITING_DATA_TO_CLIENT(CHILD_SERV,ROOT,FILEINFO,METHOD_OR_ERROR,HTTP_VER,Cfg,
                             ACT_USER.OWNIPAD,ACT_USER.OWNPADR,ACT_USER.IPADR,ACT_USER.RMPADR);
    FIN;

    LEAVE ConfigSema;
  END;

 END; ! SERVER-Proc
!----------------------------------------------------------------------

HTTP_Reload: TASK PRIO 18 RESIDENT ;
DCL ok BIT;

   #IF SICOLOG
     PUT GetLogfileCode( LC_RECONFIGSTART ) TO HTPD_Alarm_out BY LIST,SKIP;
   #FIN;
   ok = READ_KONFIGURATION;
   #IF SICOLOG
     IF ok
     THEN
       PUT GetLogfileCode( LC_RECONFIGOK ) TO HTPD_Alarm_out BY LIST,SKIP;
     ELSE
       PUT GetLogfileCode( LC_RECONFIGERR ) TO HTPD_Alarm_out BY LIST,SKIP;
     FIN;
   #FIN;

   #IF MAXILOG
       IF ok THEN
          WRITE 'D: Demon konfiguration changed.'\0D\'' TO HTPD_LOGLINK;
       ELSE
          WRITE 'F: Demon konfiguration NOT changed.'\0D\'' TO HTPD_LOGLINK;
       FIN ;
   #FIN
END ;


#IF MAXILOG+MINILOG
! *******************************************************************
! The following PROC 'WRITELOG' is a slave of the task HTTP_Logger
! *******************************************************************

WRITELOG: PROC;

  DCL TO_BE_DONE FIXED;
  TO_BE_DONE = LOGBUFCNT;


  IF TO_BE_DONE > 0 THEN
    OPEN LOGFILE; APPEND(LOGFILE);
    IF ST(LOGFILE) NE 0 THEN
      #IF SICOLOG ;
      #ELSE ;
      PUT 'Trouble with LOGFILE. Switched to /NIL!' TO HTPD_Alarm_out
           BY SKIP,A,SKIP;
      #FIN;
      OPEN LOGFILE BY IDF('/NIL');
    FIN;  ! Cannot open LOGFILE;
    FOR I TO 10 REPEAT
      IF TO_BE_DONE GE 100 THEN
         PUT LOGBUFFER(I) TO LOGFILE BY A(100);
         TO_BE_DONE=TO_BE_DONE-100;
      ELSE
         IF TO_BE_DONE > 0 THEN
            PUT LOGBUFFER(I) TO LOGFILE BY A(TO_BE_DONE);
         FIN;
         EXIT;
      FIN;
    END;  ! For I to 10 repeat
    CLOSE LOGFILE;
  FIN; ! If something to do
  LOGBUFCNT=0;
  RETURN;
END; ! WRITELOG
! *******************************************************************
!                                                                   *
!                 T A S K   H T T P _ L o g g e r                   *
!                                                                   *
!   This process performs the buffered logging of all events        *
!   inside the HTTP-Server or inside the applications. It writes    *
!   the LOGBUFFER to the logfile whenever the buffer is almost      *
!   full.
! *******************************************************************
 HTTP_Logger: TASK PRIO 5 RESIDENT;

  DCL IN_CE PEARL_CE;      ! The incoming CE
  DCL TBUF CLOCK;          ! The internal Time-buffer
  DCL LEN FIXED;           ! Rapid access to text-length
  DCL CPTR REF CHAR(1);    ! Character-pointer source
  DCL CE_ADR REF STRUCT[]; ! The CE itself

  DCL LOGBUFPTR REF CHAR(1);  ! Current Pointer to store data
  DCL LOGBUFORG REF CHAR(1);  ! Origin of LOGBUFFER
  DCL CLOCKSTR CHAR(13);      ! The CLOCK-String

  LOGBUFORG=LOGBUFFER(1).CHAR(1);
  IF LOGBUFCNT == 0 THEN LOGBUFPTR=LOGBUFORG; FIN;

  REPEAT                   ! Do foreever
    CE_ADR=TOQ_CE();
    IF CE_ADR IS NIL THEN EXIT; FIN;  ! may leave the loop
    GET_CE_DATA(CE_ADR,IN_CE);        ! Grab what is comin in
    TBUF=NOW;              ! Grab actual time
    IF LASTLOGCLK GT TBUF THEN              ! if a new day
       LASTLOGDATE = DATE;
       LASTLOGCLK = TBUF;
       CONT LOGBUFPTR=''\0D\''; REFADD(LOGBUFPTR,1);
       CONT LOGBUFPTR=''\0A\''; REFADD(LOGBUFPTR,1);
       CONT LOGBUFPTR=''\0D\''; REFADD(LOGBUFPTR,1);
       CONT LOGBUFPTR=''\0A\''; REFADD(LOGBUFPTR,1);
       CPTR=LASTLOGDATE.CHAR(1);
       TO 10 REPEAT
          CONT LOGBUFPTR=CPTR; REFADD(CPTR,1);REFADD(LOGBUFPTR,1);
       END;
       CONT LOGBUFPTR=' '; REFADD(LOGBUFPTR,1);
       LOGBUFCNT=LOGBUFCNT+15; ! Summary of above insertions
    FIN;
 ! ... Normal log entry ................................................
    IF IN_CE.RECLEN == 1 AND IN_CE.DATA_ADR == ''\04\'' THEN  ! EOF?
        WRITELOG;                   ! Purge the buffer
        LOGBUFPTR=LOGBUFORG;
        RELEASE_CE(CE_ADR); EXIT;
    ELSE                            ! normal text
 ! ... Insert the clock into the buffer ...............................
       CONVERT TBUF TO CLOCKSTR BY T(12,3),X;
       CPTR=CLOCKSTR.CHAR(1);
       TO 13 REPEAT
         CONT LOGBUFPTR=CPTR; REFADD(CPTR,1); REFADD (LOGBUFPTR,1);
       END;
       LOGBUFCNT=LOGBUFCNT+13;
 ! ... Insert the incoming text into the buffer .......................
       IF LOGBUFCNT+IN_CE.RECLEN+1 GE 1000 THEN   ! Does this fit?
         WRITELOG;
         LOGBUFPTR=LOGBUFORG;
       FIN;
       FOR I TO IN_CE.RECLEN REPEAT
         CONT LOGBUFPTR=IN_CE.DATA_ADR;
         REFADD(LOGBUFPTR,1); REFADD(IN_CE.DATA_ADR,1);
       END;
       CONT LOGBUFPTR=''\0D\''; REFADD(LOGBUFPTR,1);
       LOGBUFCNT=LOGBUFCNT+IN_CE.RECLEN+1;
       IF LOGBUFCNT > 950 THEN WRITELOG;
                               LOGBUFPTR=LOGBUFORG;
       FIN;
    FIN;
    RELEASE_CE(CE_ADR);
  END;
  ! ... This location is reached with the above EXIT-statement
  ! ... HTTP_Logger is idle here
  IF LOGBUFCNT > 750 THEN WRITELOG; LOGBUFPTR=LOGBUFORG; FIN;
  END; ! End the task
#FIN
! *******************************************************************
!                                                                   *
!                 T A S K   H T T P _ D e m o n                     *
!                                                                   *
! *******************************************************************
 HTTP_Demon : TASK PRIO DEMON_PRIO;

! .... Local Variables

 DCL Y                       CHAR(255);

 DCL NETERROR                FIXED(15)     INIT(0);
 DCL ROOT                    REF LISTE;
 DCL ZAEHLER                 FIXED(15)     INIT(0);
 DCL REMOTE_PORT_ADR         FIXED(15)     INIT(0);
 DCL CHILD                   FIXED;
 DCL NETST                   FIXED;
 DCL IPADR                   FIXED(31);    ! Accepted IP-Address
 DCL OWNIPADR                FIXED(31);    ! Own IP-Address
 DCL OWNPADR                 FIXED;        ! Own Port
 DCL ACT_USER                FIXED;        ! Actual accepted user
 DCL ACT_USER_SLOT           FIXED;        ! 1 ... MAX_USER
 DCL Errorcount              FIXED;        ! For repeated accept errors
 DCL AUTP            REF     TUSER;        ! Actual user-tab pointer
 DCL (TI,TI2)                FIXED;        ! Temporary integer
#IF SERVER_INACTIVE_TIME > 0 ;
  DCL kill_one FIXED    ;
  DCL tdiff    DURATION ;
  DCL k_kill   FIXED    ;
#FIN
  DCL ok BIT(1) ;
  DCL Cfg REF THTTPConfig;

 CALL file_sema_set_all ;

 #IF SICOLOG;
   PUT GetLogfileCode( LC_VOID ),'HTTPServ ',MAJORVERSION,'.',MINORVERSION TO HTPD_Alarm_out BY LIST,X,A,F(FFORM30(MAJORVERSION)),A,F(FFORM30(MINORVERSION)),SKIP;
 #ELSE;
   OPEN HTPD_Alarm_out BY IDF( '/TY' ) ;
 #FIN;
! ... Fill the conversion table CAPTAB ................................

 FOR I FROM 0 TO 255 REPEAT
   CASE TOCHAR(I)
     ALT('a':'z') CAPTAB(I)=TOCHAR(I-32);  ! $61 to $41 etc
     OUT CAPTAB(I)=TOCHAR(I);
   FIN;
 END;


 ! .... Install Logging system if required
 #IF MAXILOG+MINILOG
   LOGBUFCNT=0;           ! Reset Buffer-Counter
   OPEN HTPD_LOGLINK BY IDF('/HTTP_Logger');
   IF ST(HTPD_LOGLINK) NE 0 THEN
     #IF SICOLOG;
       PUT GetLogfileCode( LC_LOGERROR ), 'HTTP_Logger' TO HTPD_Alarm_out BY LIST,X,A,SKIP;
     #ELSE  ;
       PUT 'Cannot connect to Logging Task!' TO HTPD_Alarm_out BY SKIP,A,SKIP;
     #FIN;
     OPEN HTPD_LOGLINK BY IDF('/NIL');
   FIN;
   LASTLOGCLK = 23:59:59;
 #FIN

 IF NOT READ_KONFIGURATION THEN GOTO HTTP_No_Start ; FIN ;

! .... Reset all users to 'not active' .........................

  FOR I TO MAX_USER REPEAT           ! All user-slots
    AUTP = USERTAB(I);               ! set base pointer
    AUTP.IPADR = 0(31);              ! Mark it as "free" slot
    AUTP.OWNIPAD = 0(31);
    AUTP.RMPADR = 0;
    AUTP.OWNPADR = 0;
    AUTP.CHILD = -1;                 ! No socket in progress
    AUTP.USERNO = 0;                 ! No user installed
    AUTP.RI = 1;                     ! Set the cyclic buffer
    AUTP.WI = 1;                     ! To empty
    AUTP.LOGIN  = DFLOG;             ! Set login state defaulted
  END; ! Users reset

!.... Open protocol file if requested ..........................

  #IF MINILOG+MAXILOG
      ENTER ConfigSema;
      Cfg = HTTPConfig( AktConfig );
      OPEN LOGFILE
           BY IDF(KON(Cfg.LOCPATH,1,Cfg.LOCPATH_Len,'HTTPPROT.LOG',1,12)),ANY;
      LEAVE ConfigSema;
      IF ST(LOGFILE) NE 0 THEN
        #IF SICOLOG;
          PUT GetLogfileCode( LC_LOGERROR ), 'HTTPPROT.LOG' TO HTPD_Alarm_out BY LIST,X,A,SKIP;
        #ELSE  ;
          WRITE 'Trouble opening logfile: ' TO HTPD_Alarm_out;
        #FIN;
        GOTO HTTP_No_Start;
      FIN;
      CLOSE LOGFILE;    ! This file will be administered by 'WRITELOG'
      WRITE ' ' TO HTPD_LOGLINK;
      WRITE '***************************' TO HTPD_LOGLINK;
      WRITE '* New Start of HTTP_Demon.*' TO HTPD_LOGLINK;
      WRITE '***************************' TO HTPD_LOGLINK;
  #FIN

#IF IEP_SOCKET > 0 ;
  CALL IEP_NET_INIT ;
#ELSE
  ENTER ConfigSema;
  Cfg = HTTPConfig( AktConfig );
  STARTSEQUENZ(NETST, Cfg);
  LEAVE ConfigSema;

  IF NETST NE 0 THEN
     WRITE 'Trouble with NETLINK-init'\0D0A\'' TO HTPD_Alarm_out;
     GOTO HTTP_No_Start;
  FIN;
#FIN ;

  Errorcount = 0;

  #IF SICOLOG;
    PUT GetLogfileCode( LC_START ) TO HTPD_Alarm_out BY LIST,SKIP;
  #ELSE  ;
    WRITE 'HTTP_Demon is up and going to listen-state.'\0D0A\'' TO HTPD_Alarm_out;
  #FIN;

!------------------------- END OF DEMON-INIT ------------------------

! .... This is the main loop for processing request after request ......
  REPEAT
     #IF MAXILOG
         WRITE 'D: Demon listening.'\0D\'' TO HTPD_LOGLINK;
     #FIN

! .... The demon goes asleep here .....................................
     Y:='';
#IF IEP_SOCKET > 0 ;
     NETST = NET_OPEN( DEMON_PORT, SOCKET, IPADR, REMOTE_PORT_ADR,OWNIPADR,OWNPADR,HTPD_Alarm_out, HTPD_LOGLINK ) ; /* open a passive connection and wait */
#ELSE
     NETST=NETLINK(SOCKET,Y.CHAR(1),16,SO_ACCEPT,FLG_WAIT,HTPD_Alarm_out, HTPD_LOGLINK); ! HIER WARTEN
#FIN ;
! .... Inspect the new connection .....................................

     #IF SICOLOG;
       NETERROR=NETSTERR(NETST,'0'B,HTPD_Alarm_out);
     #ELSE;
       NETERROR=NETSTERR(NETST,'1'B,HTPD_Alarm_out);
     #FIN;

!.....  Testen, ob der Accept funktioniert hat ......................

     IF NETST < 0 THEN
        IF NETST EQ -32752 THEN           ! QUEUE LENGTH EXCEEDED!
           AFTER 10 SEC RESUME;
           GOTO NEXTROUND;
        ELSE
           #IF SICOLOG;
             PUT GetLogfileCode( LC_ACCEPTERR ) TO HTPD_Alarm_out BY LIST,SKIP;
           #ELSE  ;
            WRITE 'HTTP_Demon: Error with accept!'\0D0A\'' TO HTPD_Alarm_out;
           #FIN;
           #IF MINILOG+MAXILOG
             WRITE 'D: Accept-error!' TO HTPD_LOGLINK;
           #FIN
           Errorcount=Errorcount+1;
           IF Errorcount > 4 THEN
             #IF SICOLOG;
               PUT GetLogfileCode( LC_ACCEPTERR4 ) TO HTPD_Alarm_out BY LIST,SKIP;
             #ELSE  ;
               WRITE '4 consecutive errors: HTTP_Demon terminated!'\0D0A\''
                     TO HTPD_Alarm_out;
             #FIN;
             #IF MINILOG+MAXILOG
               WRITE 'D: 4 consecutive Accept-errors, demon terminated!'
                     TO HTPD_LOGLINK;
             #FIN
             CLOSESOCKET(SOCKET);
             TERMINATE;
           FIN;  ! If Errorcount > 4

        FIN; ! IF NETST EQ -32752 THEN !
        GOTO NEXTROUND;

     FIN;  ! If NETST LT 0
! .... Successful accept: reset Errorcount ...........................
     Errorcount=0;
!.....  Identify client ..............................................

#IF IEP_SOCKET > 0 ;
     CHILD = SOCKET ;
#ELSE
     CHILD=NETST;
     Y.CHAR(1)=TOCHAR(0);
     Y.CHAR(2)=TOCHAR(AF_INET);
     Y.CHAR(3)=TOCHAR(0);
     Y.CHAR(4)=TOCHAR(0);
     Y.CHAR(5)=TOCHAR(0);
     Y.CHAR(6)=TOCHAR(0);
     Y.CHAR(7)=TOCHAR(0);
     Y.CHAR(8)=TOCHAR(0);
     NETST=NETLINK(CHILD,Y.CHAR(1),16,SO_GETREMADDR,FLG_WAIT,HTPD_Alarm_out, HTPD_LOGLINK);
     IPADR = TOFIXED(Y.CHAR(5));
     IPADR = IPADR*256+TOFIXED(Y.CHAR(6));
     IPADR = IPADR*256+TOFIXED(Y.CHAR(7));
     IPADR = IPADR*256+TOFIXED(Y.CHAR(8));

#FIN
! ..... Check permission of the new user ...............................
     ENTER ConfigSema;
     Cfg = HTTPConfig( AktConfig );

     IF (TOBIT(IPADR) AND TOBIT(Cfg.VARTAB(IP_MASK1_IDX).IValue))
         NE TOBIT(Cfg.VARTAB(IP_ALLOW1_IDX).IValue)   AND
         (TOBIT(IPADR) AND TOBIT(Cfg.VARTAB(IP_MASK2_IDX).IValue))
         NE TOBIT(Cfg.VARTAB(IP_ALLOW2_IDX).IValue)    THEN
        #IF MAXILOG
           WRITE 'D: Remote IP-Adr is not permitted, connection closed.'
                 TO HTPD_LOGLINK;
        #FIN; ! PREPROZESSOR-BEFEHL !
        LEAVE ConfigSema;
        CALL CLOSESOCKET(CHILD);
        GOTO NEXTROUND;
     FIN; !IF TOFIXED(Y.CHAR(5)) NE ALLOW_IP_1 AND TOFIXED(Y.CHAR(6)) NE ...!

!...... IP-adr wurde akzeptiert ................................................

!.......   Find actual user-slot .....................................


DO_IT_AGAIN:
     ACT_USER = 0;
     ACT_USER_SLOT = -1;
/*
     FOR I FROM MAX_USER BY -1 TO 1 REPEAT;
       AUTP = USERTAB(I);
       IF AUTP.IPADR EQ IPADR THEN
         ACT_USER = AUTP.USERNO;
         ACT_USER_SLOT = I;          EXIT;
       FIN;
       IF AUTP.IPADR EQ 0(31) THEN
         ACT_USER_SLOT = I;
         ACT_USER = 0;
       FIN;
     END; ! I from MAX_USER to 1
*/
     FOR I FROM MAX_USER BY -1 TO 1 REPEAT;
       AUTP = USERTAB(I);
       IF AUTP.WI == 1 THEN
         ACT_USER = AUTP.USERNO;
         ACT_USER_SLOT = I;
         LEAVE ConfigSema;
         EXIT;
       FIN;
     END; ! I from MAX_USER to 1

     IF ACT_USER_SLOT EQ -1 THEN

/*
#IF SERVER_INACTIVE_TIME > 0 ;

        ! ####KROLL#### Einbau Anfang
        ! no free place found
        kill_one = 0 ;
        FOR I FROM MAX_USER BY -1 TO 1 REPEAT ;
           tdiff = ( NOW - USERTAB(I).LASTREQ ) ;
           IF tdiff LT 0 HRS THEN tdiff = tdiff + 24 HRS ; FIN ;
           IF tdiff GT SERVER_INACTIVE_TIME * 1 SEC  THEN
              ! Kill the unused one
              k_kill = RUN_USER(USERTAB(I).USERNO,'#HTTPUSR',NIL,NIL,0(31));
              #IF MAXILOG
                  PUT 'D: Have killed User on Slot #',I,k_kill  TO HTPD_Alarm_out BY A,F(4),F(4),SKIP;
                  PUT 'D: Have killed User on Slot #',I,k_kill  TO HTPD_LOGLINK BY A,F(4),F(4);
              #FIN;

              USERTAB(I).IPADR = 0(31) ;
              kill_one = kill_one + 1 ;
           FIN ;
        END ;
        IF kill_one GT 0 THEN
           GOTO DO_IT_AGAIN ;
        FIN ;
        ! ####KROLL#### Einbau Ende
#FIN
*/

        #IF SICOLOG;
          PUT GetLogfileCode( LC_START ) TO HTPD_Alarm_out BY LIST,SKIP;
        #ELSE  ;
          PUT 'Too many users!' TO HTPD_Alarm_out BY A,SKIP;  ! Too many users
        #FIN;

        LEAVE ConfigSema;
        AFTER 1 SEC RESUME;
        ENTER ConfigSema;
        Cfg = HTTPConfig( AktConfig );
        GOTO DO_IT_AGAIN;
     FIN;
!......    We have a slot for the request ............................
#IF IEP_SOCKET > 0 ;
#ELSE
     REMOTE_PORT_ADR:=TOFIXED(Y.CHAR(3))*256+TOFIXED(Y.CHAR(4));
     #IF MAXILOG+MINILOG;
       #IF MINILOG;
         IF ACT_USER EQ 0 THEN        ! First contact ?
       #FIN;
            PUT 'D: Remote address: ',TOFIXED(Y.CHAR(5)),'.',
                                            TOFIXED(Y.CHAR(6)),'.',
                                            TOFIXED(Y.CHAR(7)),'.',
                                            TOFIXED(Y.CHAR(8)),':',
                          REMOTE_PORT_ADR TO HTPD_LOGLINK BY
                          A,F(3),A(1),F(3),A(1),F(3),A(1),F(3),A(1),F(8);
       #IF MINILOG;
         FIN;
       #FIN;
     #FIN;
#FIN

     #IF MAXILOG
         PUT 'D: Connected on socket #',CHILD
             TO HTPD_LOGLINK BY A,F(4);
     #FIN;

     ! Switch to UserSlot ####KROLL### fehlte vorher
     AUTP = USERTAB( ACT_USER_SLOT ) ;

     AUTP.IPADR = IPADR;
     AUTP.RMPADR = REMOTE_PORT_ADR;
     AUTP.OWNIPAD = OWNIPADR;
     AUTP.OWNPADR = OWNPADR;

!.... Insert the child-sock into ringbuffer ......................
     TI = AUTP.WI;
     TI2= TI;                                     ! Get writer-index
!     TI = TI +1; IF TI > MAX_CQ THEN TI = 1; FIN; ! Move to next slot
!     IF TI NE AUTP.RI THEN                        ! Buffer not full?
     TI = TI +1;
     IF '1'B THEN
       AUTP.CBUF(TI2) = CHILD;                    ! Insert child
       AUTP.WI = TI;                              ! Set index new
       #IF MAXILOG
         PUT 'D: Handing over to Server-shell:',ACT_USER TO HTPD_LOGLINK BY A,F(5);
       #FIN
#IF DBG_ME_VERSION > 0 ;
       SERVER( AUTP ) ;
       TI2 = 0 ;
#ELSE
       AUTP.USERNO = -1;
       TI2 = RUN_USER(ACT_USER,'#HTTPUSR',SERVER,AUTP,4000(31));
#FIN
       IF TI2 == 0 THEN                           ! Shell nicht instal.
         #IF MAXILOG+MINILOG
           WRITE 'D: No shell available!' TO HTPD_LOGLINK;
         #FIN;
         CALL CLOSESOCKET(CHILD);
       FIN;

     ELSE               ! ...... Buffer overrun ..................

       #IF SICOLOG ;
         PUT GetLogfileCode( 28 ) TO HTPD_Alarm_out BY LIST,SKIP;
       #ELSE
         WRITE 'HTTP-Demon: Socket-buffer overflow!'\0A0D\'' TO HTPD_Alarm_out;
       #FIN;

! Hier weitere Massnahmen ergaenzen

       #IF MAXILOG+MINILOG
         WRITE 'D: Shell-socket-buffer overflow!' TO HTPD_LOGLINK;
       #FIN
       CALL CLOSESOCKET(CHILD);
     FIN;
     LEAVE ConfigSema;

  NEXTROUND:
  END; ! REPEAT Main loop

!-------------------------------------------------------------------

! .... HTTP_Demon did not Start ...................

 HTTP_No_Start:
 #IF MAXILOG+MINILOG
   WRITE ''\04\'' TO HTPD_LOGLINK;
 #FIN
 #IF SICOLOG ;
   PUT GetLogfileCode( 2 ) TO HTPD_Alarm_out BY LIST,SKIP;
 #ELSE
   WRITE 'HTTP_Demon terminated.'\0D0A\'' TO HTPD_Alarm_out;
 #FIN;

 END;

 APPL_CLEAN_HTTP : PROC((Stdin,Stdout,Stderr) DATION INOUT ALPHIC IDENT,
                         Length FIXED, Text CHAR(255)) RETURNS(BIT(1));

   RESERVE ConfigSema;
   FOR I TO 1 UPB HTTPConfig(1).APPLICATIONPTR REPEAT
     HTTPConfig(1).APPLICATIONPTR(I)=NIL;
     HTTPConfig(2).APPLICATIONPTR(I)=NIL;
   END;
   FREE ConfigSema;

   RETURN('1'B) ;
 END ;

HTTP_DISABLE_MODULE : PROC((Stdin,Stdout,Stderr) DATION INOUT ALPHIC IDENT,
                         Length FIXED, Text CHAR(255)) RETURNS(BIT(1));

DCL Cfg REF THTTPConfig;
DCL Module CHAR(24);
DCL Found BIT INIT('0'B);
DCL VOIDPtr REF STRUCT[];
DCL CharPtr REF CHAR(24);

   IF Length == 0
   THEN
     PUT 'Usage: HTTP_DISABLE_MODULE modulename' TO Stderr BY LIST,SKIP;
     RETURN('0'B);
   FIN;

   Module = KON( Text, 1, Length, '.', 1, 1 );

   RESERVE ConfigSema;

   Cfg = HTTPConfig( AktConfig );

   FOR I FROM 1 TO 1 UPB Cfg.VARTAB REPEAT
     IF    Cfg.VARTAB(I).Descr == vtApplication OR Cfg.VARTAB(I).Descr == vtApplication2
        OR Cfg.VARTAB(I).Descr == vtApplication3 THEN

        VOIDPtr = Cfg.TxtPool(Cfg.VARTAB(I).IValue);
        CharPtr = VOIDPtr;

       IF INSTR(Module,1,Length + 1,CharPtr,1,Length+1)  == 1
       THEN        ! We found an application
         Cfg.APPENABLED(I) = '0'B;
         Cfg.APPLICATIONPTR(I) = NIL;   ! Delete dynamic link
         Found = '1'B;
        FIN;
     FIN;
   END;
   FREE ConfigSema;

   IF NOT Found
   THEN
     PUT 'HTTP_DISABLE_MODULE: ', Text, ' not found.' TO Stderr BY LIST,A(Length),A,SKIP;
     RETURN('0'B);
   FIN;

   RETURN('1'B) ;
 END ;

HTTP_ENABLE_MODULE : PROC((Stdin,Stdout,Stderr) DATION INOUT ALPHIC IDENT,
                         Length FIXED, Text CHAR(255)) RETURNS(BIT(1));

DCL Cfg REF THTTPConfig;
DCL Module CHAR(24);
DCL Found BIT INIT('0'B);
DCL VOIDPtr REF STRUCT[];
DCL CharPtr REF CHAR(24);

   IF Length == 0
   THEN
     PUT 'Usage: HTTP_ENABLE_MODULE modulename' TO Stderr BY LIST,SKIP;
     RETURN('0'B);
   FIN;

   Module = KON( Text, 1, Length, '.', 1, 1 );

   RESERVE ConfigSema;

   Cfg = HTTPConfig( AktConfig );

   FOR I FROM 1 TO 1 UPB Cfg.VARTAB REPEAT
     IF    Cfg.VARTAB(I).Descr == vtApplication OR Cfg.VARTAB(I).Descr == vtApplication2
        OR Cfg.VARTAB(I).Descr == vtApplication3 THEN

        VOIDPtr = Cfg.TxtPool(Cfg.VARTAB(I).IValue);
        CharPtr = VOIDPtr;

       IF INSTR(Module,1,Length + 1,CharPtr,1,Length+1)  == 1
       THEN        ! We found an application
         Cfg.APPENABLED(I) = '1'B;
         Cfg.APPLICATIONPTR(I) = NIL;   ! Delete dynamic link
         Found = '1'B;
        FIN;
     FIN;
   END;
   FREE ConfigSema;

   IF NOT Found
   THEN
     PUT 'HTTP_ENABLE_MODULE: ', Text, ' not found.' TO Stderr BY LIST,A(Length),A,SKIP;
     RETURN('0'B);
   FIN;

   RETURN( '1'B) ;
 END ;


! ***************************************************************
!                    T H E   K i l l e r
! ***************************************************************

 KILL_HTTP : PROC((Stdin,Stdout,Stderr) DATION INOUT ALPHIC IDENT,
                  Length FIXED, Text CHAR(255)) RETURNS(BIT(1));

  DCL (J,K)  FIXED;
  DCL VOIDPT REF STRUCT[];
  DCL CHARPT REF CHAR(4);       ! for treating IP-adr

  TERMINATE HTTP_Demon;
  #IF MAXILOG+MINILOG
    WRITE ''\0D0D\'' TO HTPD_LOGLINK;
    WRITE         '****************************' TO HTPD_LOGLINK;
    WRITE         '  -- Killer was called --'    TO HTPD_LOGLINK;
    WRITE         '****************************'\0D\'' TO HTPD_LOGLINK;
    WRITE 'Killer: HTTP_Demon terminated.' TO HTPD_LOGLINK;
  #FIN
  CLOSESOCKET(SOCKET);       ! The main socket
  #IF MAXILOG+MINILOG;
    WRITE 'Killer: Main socket port 80 closed.' TO HTPD_LOGLINK;
  #FIN;
!..... Removing all user-sockets ..............................

  FOR I TO MAX_USER REPEAT
   IF USERTAB(I).IPADR NE 0(31) THEN
     #IF MAXILOG+MINILOG
       VOIDPT = USERTAB(I).IPADR;
       CHARPT=VOIDPT;
       PUT 'Killer: Removing log-entry of ',
         TOFIXED(CHARPT.CHAR(1)),'.',
         TOFIXED(CHARPT.CHAR(2)),'.',
         TOFIXED(CHARPT.CHAR(3)),'.',
         TOFIXED(CHARPT.CHAR(4))
         TO HTPD_LOGLINK BY A,F(3),A,F(3),A,F(3),A,F(3);
     #FIN
     BEGIN
       DCL (RIPTR,WIPTR) REF FIXED;
       WIPTR=USERTAB(I).WI;
       RIPTR=USERTAB(I).RI;
       WHILE  WIPTR NE RIPTR REPEAT   ! any sockets open?
          CLOSESOCKET(USERTAB(I).CBUF(RIPTR));
          #IF MAXILOG+MINILOG
             PUT 'Killer: Removing queued socket ', USERTAB(I).CBUF(RIPTR)
                TO HTPD_LOGLINK;
          #FIN
          CONT RIPTR = RIPTR+1;
          IF RIPTR GT MAX_CQ THEN CONT RIPTR=1; FIN;
       END;   ! WHILE-Loop
     END;  ! BEGIN
     IF USERTAB(I).CHILD GT 0 THEN
        CLOSESOCKET(USERTAB(I).CHILD);
        #IF MAXILOG+MINILOG ;
          WRITE 'Killer: Mainsocket closed.' TO HTPD_LOGLINK;
        #FIN;
     FIN;
!*........ Removing all user-shells .....................
     J = USERTAB(I).USERNO;
     IF J > 0 THEN
       K=RUN_USER(J,'#HTTPUSR',NIL,NIL,0(31));
       #IF MINILOG+MAXILOG ;
         IF K LE 0 THEN
            PUT 'Killer: Failed to remove user ', J
               TO HTPD_LOGLINK BY A,F(3);
         ELSE
            PUT 'Killer: Success removing user ',J
               TO HTPD_LOGLINK BY A,F(3);
         FIN;
       #FIN;
     FIN;
   FIN; ! USERTAB(I).IPADR NE 0
  END;  ! FOR I TO MAX_USER ....
  #IF MAXILOG+MINILOG;
    WRITE 'Killer: Work is done!' TO HTPD_LOGLINK;
    WRITE ''\04\'' TO HTPD_LOGLINK;    ! Emit log-buffer to disc
  #FIN
 RETURN('1'B);
END;

#IF MAXILOG+MINILOG;
HTTP_SHOW_FILES: TASK ;
  DCL f REF FIXED(15);
  DCL VOIDPTR REF STRUCT [];

  VOIDPTR = GLB_FILE_WAIT( 1 ) ;
  f = VOIDPTR;

  FOR i TO 1 UPB GLB_FILE_WAIT REPEAT;
     PUT 'GLB_FILE_WAIT(',i,')=',f TO HTPD_Alarm_out BY A,F(2),A,F(3),X,SKIP;
     CALL REFADD( f , 1 );
  END;

  VOIDPTR = GLB_FILE_SEMA ;
  f = VOIDPTR;
  PUT 'GLB_FILE_SEMA=',f TO HTPD_Alarm_out BY SKIP,A,F(3),X,SKIP;

  VOIDPTR = GLB_FILE_FREE ;
  f = VOIDPTR;
  PUT 'GLB_FILE_FREE=',f TO HTPD_Alarm_out BY SKIP,A,F(3),X,SKIP;

  FOR i TO 1 UPB GLB_FILE_NAMES  REPEAT;
     IF GLB_FILE_NAMES(i).cnt NE 0 THEN
        PUT i,GLB_FILE_NAMES(i).cnt,'<',GLB_FILE_NAMES(i).t,'>' TO HTPD_Alarm_out BY F(2),X,F(2),X,A,A(LEN(GLB_FILE_NAMES(i).t)),A,SKIP;
     FIN;
  END;

END;
#FIN

MODEND;

